package com.ejie.y38a.control;

import com.ejie.x38.control.exception.ControlException;
import com.ejie.x38.control.exception.MethodFailureException;
import com.ejie.x38.control.exception.ResourceNotFoundException;
import com.ejie.x38.control.exception.ServiceUnavailableException;
import com.ejie.x38.dto.JQGridJSONModel;
import com.ejie.x38.dto.Pagination;
import com.ejie.x38.util.ObjectConversionManager;
import com.ejie.y38a.model.Establec;
import com.ejie.y38a.model.Sectores;
import com.ejie.y38a.service.AdheestaService;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;
import java.util.Properties;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;

import com.ejie.y38a.model.Adheesta;

/**
 * * AdheestaController  
 * 
 *  
 */

@Controller
@RequestMapping(value = "/adheesta")
public class AdheestaController {

	private static final Logger logger = LoggerFactory
			.getLogger(AdheestaController.class);

	@Autowired
	private AdheestaService adheestaService;

	@Autowired
	private Properties appConfiguration;

	/**
	 * Method 'getCreateForm'.
	 * 
	 * @param model
	 *            Model
	 * @return String
	 */
	@RequestMapping(value = "maint", method = RequestMethod.GET)
	public ModelAndView getCreateForm(Model model) {
		model.addAttribute("defaultLanguage",
				appConfiguration.get("y38aAppWar.default.language"));
		model.addAttribute("defaultLayout",
				appConfiguration.get("y38aAppWar.default.layout"));
		return new ModelAndView("adheesta", "model", model);
	}

	/**
	 * Method 'getById'.
	 * 
	 * @param ahcodigo
	 *            String
	 * @param establecEscodigo
	 *            String
	 * @return String
	 */
	@RequestMapping(value = "/{ahcodigo}/{establecEscodigo}", method = RequestMethod.GET)
	public @ResponseBody
	Adheesta getById(@PathVariable String ahcodigo,
			@PathVariable String establecEscodigo) {
		try {
			Adheesta adheesta = new Adheesta();
			adheesta.setEstablec(new Establec());
			adheesta.setAhcodigo(ahcodigo);
			adheesta.getEstablec().setEscodigo(establecEscodigo);
			adheesta = this.adheestaService.find(adheesta);
			if (adheesta == null) {
				throw new Exception(ahcodigo.toString()
						+ establecEscodigo.toString());
			}
			return adheesta;
		} catch (Exception e) {
			throw new ResourceNotFoundException(ahcodigo.toString()
					+ establecEscodigo.toString());
		}
	}

	/**
	 * Method 'getAll'.
	 * 
	 * @param ahcodigo
	 *            String
	 * @param establecEscodigo
	 *            String
	 * @param sectoresSecodigo
	 *            String
	 * @param ahcoex
	 *            Integer
	 * @param ahnrdi
	 *            Integer
	 * @param ahfecodi
	 *            Date
	 * @param ahfeba
	 *            Date
	 * @param ahcotag
	 *            String
	 * @param ahcot2
	 *            String
	 * @param ahcoav
	 *            String
	 * @param ahcosede
	 *            String
	 * @param ahfepucd
	 *            Date
	 * @param ahfepuba
	 *            Date
	 * @param ahcocc
	 *            String
	 * @param ahnirep
	 *            String
	 * @param ahnorep
	 *            String
	 * @param ahnoap1r
	 *            String
	 * @param ahnoap2r
	 *            String
	 * @param ahnocare
	 *            String
	 * @param ahfere
	 *            Date
	 * @param ahtelimi
	 *            String
	 * @param ahinamna
	 *            String
	 * @param ahcoja
	 *            String
	 * @param ahcozs
	 *            String
	 * @param ahcojaad
	 *            String
	 * @param request
	 *            HttpServletRequest
	 * @return String
	 */
	@RequestMapping(method = RequestMethod.GET)
	public @ResponseBody
	Object getAll(
			@RequestParam(value = "ahcodigo", required = false) String ahcodigo,
			@RequestParam(value = "establecEscodigo", required = false) String establecEscodigo,
			@RequestParam(value = "sectoresSecodigo", required = false) String sectoresSecodigo,
			@RequestParam(value = "ahcoex", required = false) Integer ahcoex,
			@RequestParam(value = "ahnrdi", required = false) Integer ahnrdi,
			@RequestParam(value = "ahfecodi", required = false) Date ahfecodi,
			@RequestParam(value = "ahfeba", required = false) Date ahfeba,
			@RequestParam(value = "ahcotag", required = false) String ahcotag,
			@RequestParam(value = "ahcot2", required = false) String ahcot2,
			@RequestParam(value = "ahcoav", required = false) String ahcoav,
			@RequestParam(value = "ahcosede", required = false) String ahcosede,
			@RequestParam(value = "ahfepucd", required = false) Date ahfepucd,
			@RequestParam(value = "ahfepuba", required = false) Date ahfepuba,
			@RequestParam(value = "ahcocc", required = false) String ahcocc,
			@RequestParam(value = "ahnirep", required = false) String ahnirep,
			@RequestParam(value = "ahnorep", required = false) String ahnorep,
			@RequestParam(value = "ahnoap1r", required = false) String ahnoap1r,
			@RequestParam(value = "ahnoap2r", required = false) String ahnoap2r,
			@RequestParam(value = "ahnocare", required = false) String ahnocare,
			@RequestParam(value = "ahfere", required = false) Date ahfere,
			@RequestParam(value = "ahtelimi", required = false) String ahtelimi,
			@RequestParam(value = "ahinamna", required = false) String ahinamna,
			@RequestParam(value = "ahcoja", required = false) String ahcoja,
			@RequestParam(value = "ahcozs", required = false) String ahcozs,
			@RequestParam(value = "ahcojaad", required = false) String ahcojaad,
			HttpServletRequest request) {
		try {
			Adheesta filterAdheesta = new Adheesta(ahcodigo,
					new Establec(establecEscodigo, null, null, null, null,
							null, null, null, null, null, null, null, null,
							null, null, null, null, null, null, null, null,
							null, null, null, null, null, null, null, null,
							null, null, null, null, null, null, null, null,
							null, null, null, null, null, null, null, null,
							null, null, null, null, null, null, null, null,
							null, null, null, null, null, null, null, null,
							null, null, null, null, null, null, null), ahcoex,
					ahnrdi, ahfecodi, ahfeba, ahcotag, ahcot2, ahcoav,
					ahcosede, ahfepucd, ahfepuba, ahcocc, ahnirep, ahnorep,
					ahnoap1r, ahnoap2r, ahnocare, ahfere, ahtelimi, ahinamna,
					ahcoja, ahcozs, ahcojaad, new Sectores(sectoresSecodigo,
							null, null, null, null, null, null, null, null,
							null, null, null, null, null, null, null, null,
							null, null, null, null, null));
			Pagination pagination = null;
			if (request.getHeader("JQGridModel") != null
					&& request.getHeader("JQGridModel").equals("true")) {
				pagination = new Pagination();
				pagination.setPage(Long.valueOf(request.getParameter("page")));
				pagination.setRows(Long.valueOf(request.getParameter("rows")));
				pagination.setSort(request.getParameter("sidx"));
				pagination.setAscDsc(request.getParameter("sord"));
				List<Adheesta> adheestas = this.adheestaService.findAll(
						filterAdheesta, pagination);

				if (adheestas == null) {
					throw new Exception("No data Found.");
				}

				Long total = getAllCount(filterAdheesta, request);
				JQGridJSONModel data = new JQGridJSONModel();
				data.setPage(request.getParameter("page"));
				data.setRecords(total.intValue());
				data.setTotal(total, pagination.getRows());
				data.setRows(adheestas);
				return data;
			} else {
				List<Adheesta> adheestas = this.adheestaService.findAll(
						filterAdheesta, pagination);
				if (adheestas == null) {
					throw new Exception("No data Found.");
				}
				return adheestas;
			}
		} catch (Exception e) {
			throw new ResourceNotFoundException("No data Found.");
		}
	}

	/**
	 * Method 'getAllCount'.
	 * 
	 * @param filterAdheesta
	 *            Adheesta
	 * @param request
	 *            HttpServletRequest
	 * @return Long
	 */
	@RequestMapping(value = "/count", method = RequestMethod.GET)
	public @ResponseBody
	Long getAllCount(
			@RequestParam(value = "adheesta", required = false) Adheesta filterAdheesta,
			HttpServletRequest request) {
		try {
			return adheestaService
					.findAllCount(filterAdheesta != null ? filterAdheesta
							: new Adheesta());
		} catch (Exception e) {
			throw new ServiceUnavailableException(
					"Count Service is not responding.");
		}
	}

	/**
	 * Method 'edit'.
	 * 
	 * @param adheesta
	 *            Adheesta
	 * @param response
	 *            HttpServletResponse
	 * @return Adheesta
	 */
	@RequestMapping(method = RequestMethod.PUT)
	public @ResponseBody
	Adheesta edit(@RequestBody Adheesta adheesta, HttpServletResponse response) {
		try {
			Adheesta adheestaAux = this.adheestaService.update(adheesta);
			logger.info("Entity correctly inserted!");
			return adheestaAux;
		} catch (Exception e) {
			throw new MethodFailureException("Method failed");
		}
	}

	/**
	 * Method 'add'.
	 * 
	 * @param adheesta
	 *            Adheesta
	 * @return Adheesta
	 */
	@RequestMapping(method = RequestMethod.POST)
	public @ResponseBody
	Adheesta add(@RequestBody Adheesta adheesta) {
		try {
			Adheesta adheestaAux = this.adheestaService.add(adheesta);
			logger.info("Entity correctly inserted!");
			return adheestaAux;
		} catch (Exception e) {
			throw new MethodFailureException("Method failed");
		}
	}

	/**
	 * Method 'remove'.
	 * 
	 * @param ahcodigo
	 *            String
	 * @param establecEscodigo
	 *            String
	 * @param response
	 *            HttpServletResponse
	 * @return
	 */
	@RequestMapping(value = "/{ahcodigo}/{establecEscodigo}", method = RequestMethod.DELETE)
	public void remove(@PathVariable String ahcodigo,
			@PathVariable String establecEscodigo, HttpServletResponse response) {
		response.setContentType("text/javascript;charset=utf-8");
		response.setHeader("Pragma", "cache");
		response.setHeader("Expires", "0");
		response.setHeader("Cache-Control", "private");
		try {
			Adheesta adheesta = new Adheesta();
			adheesta.setEstablec(new Establec());
			adheesta.setAhcodigo(ahcodigo);
			adheesta.getEstablec().setEscodigo(establecEscodigo);
			this.adheestaService.remove(adheesta);
			response.setStatus(HttpServletResponse.SC_OK);
		} catch (Exception e) {
			logger.error("Unable to delete " + ahcodigo + establecEscodigo);
			response.setStatus(HttpServletResponse.SC_BAD_REQUEST);
			throw new MethodFailureException("Method failed");
		}
	}

	/**
	 * Method 'removeAll'.
	 * 
	 * @param adheestaIds
	 *            ArrayList
	 * @param response
	 *            HttpServletResponse
	 * @return
	 */
	@RequestMapping(value = "/deleteAll", method = RequestMethod.POST)
	public void removeMultiple(
			@RequestBody ArrayList<ArrayList<String>> adheestaIds,
			HttpServletResponse response) {
		response.setContentType("text/javascript;charset=utf-8");
		response.setHeader("Pragma", "cache");
		response.setHeader("Expires", "0");
		response.setHeader("Cache-Control", "private");
		ArrayList<Adheesta> adheestaList = new ArrayList<Adheesta>();
		try {
			for (ArrayList<String> adheestaId : adheestaIds) {
				Iterator<String> iterator = adheestaId.iterator();
				Adheesta adheesta = new Adheesta();// NOPMD 2012/05/09 (JC)
				adheesta.setEstablec(new Establec());// NOPMD 2012/05/09 (JC)
				adheesta.setAhcodigo(ObjectConversionManager.convert(
						iterator.next(), String.class));
				adheesta.getEstablec().setEscodigo(
						ObjectConversionManager.convert(iterator.next(),
								String.class));
				adheestaList.add(adheesta);
			}
			this.adheestaService.removeMultiple(adheestaList);
			response.setStatus(HttpServletResponse.SC_OK);
		} catch (Exception e) {
			response.setStatus(HttpServletResponse.SC_BAD_REQUEST);
			throw new MethodFailureException("Method failed");
		}
	}

	/**
	 * Method 'handle'.
	 * 
	 * @param e
	 *            ControlException
	 * @return String
	 */
	@ExceptionHandler
	public @ResponseBody
	String handle(ControlException e) {
		logger.warn(e.getMessage());
		return e.getMessage();
	}

	/**
	 * Method 'getAdheestaService'.
	 * 
	 * @return AdheestaService
	 */
	protected AdheestaService getAdheestaService() {
		return this.adheestaService;
	}

	/**
	 * Method 'setAdheestaService'.
	 * 
	 * @param adheestaService
	 *            AdheestaService
	 * @return
	 */
	public void setAdheestaService(AdheestaService adheestaService) {
		this.adheestaService = adheestaService;
	}

	/**
	 * Method 'getAppConfiguration'.
	 * 
	 * @return appConfiguration
	 */
	public Properties getAppConfiguration() {
		return appConfiguration;
	}

	/**
	 * Method 'setAppConfiguration'.
	 * 
	 * @param appConfiguration
	 *            Properties
	 * @return
	 */
	public void setAppConfiguration(Properties appConfiguration) {
		this.appConfiguration = appConfiguration;
	}
}
