package com.ejie.y38a.control;

import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;
import java.util.Properties;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;

import com.ejie.x38.control.exception.ControlException;
import com.ejie.x38.control.exception.MethodFailureException;
import com.ejie.x38.control.exception.ResourceNotFoundException;
import com.ejie.x38.control.exception.ServiceUnavailableException;
import com.ejie.x38.dto.JQGridJSONModel;
import com.ejie.x38.dto.Pagination;
import com.ejie.x38.util.ObjectConversionManager;
import com.ejie.y38a.constantes.Y38aEstablecAdheConstantes;
import com.ejie.y38a.model.Establec;
import com.ejie.y38a.service.EstablecService;
import com.ejie.y38a.utils.Y38aUtils;

/**
 * * EstablecController  
 * 
 *  
 */

@Controller
@RequestMapping(value = "/establec")
public class EstablecController {

	private static final Logger logger = LoggerFactory
			.getLogger(EstablecController.class);

	@Autowired
	private EstablecService establecService;

	@Autowired
	private Properties appConfiguration;

	/**
	 * Method 'getCreateForm'.
	 * 
	 * @param model
	 *            Model
	 * @return String
	 */
	@RequestMapping(value = "maint", method = RequestMethod.GET)
	public ModelAndView getCreateForm(Model model) {
		model.addAttribute("defaultLanguage",
				appConfiguration.get("y38aAppWar.default.language"));
		model.addAttribute("defaultLayout",
				appConfiguration.get("y38aAppWar.default.layout"));

		model.addAttribute("statics_path",
				this.appConfiguration.get("statics.path"));

		return new ModelAndView("consumo", "model", model);

	}

	/**
	 * Method 'getCreateForm'.
	 * 
	 * @param model
	 *            Model
	 * @return String
	 */
	@RequestMapping(value = "maint2", method = RequestMethod.GET)
	public ModelAndView getCreateForm1(Model model) {
		model.addAttribute("defaultLanguage",
				appConfiguration.get("y38aAppWar.default.language"));
		model.addAttribute("defaultLayout",
				appConfiguration.get("y38aAppWar.default.layout"));

		model.addAttribute("statics_path",
				this.appConfiguration.get("statics.path"));

		return new ModelAndView("distintivo", "model", model);

	}

	/**
	 * Method 'getCreateForm'.
	 * 
	 * @param model
	 *            Model
	 * @return String
	 */
	@RequestMapping(value = "search", method = RequestMethod.GET)
	public ModelAndView getCreateForm2(Model model) {
		model.addAttribute("defaultLanguage",
				appConfiguration.get("y38aAppWar.default.language"));
		model.addAttribute("defaultLayout",
				appConfiguration.get("y38aAppWar.default.layout"));

		model.addAttribute("statics_path",
				this.appConfiguration.get("statics.path"));

		return new ModelAndView("search", "model", model);

	}

	// **************************************
	// pruebas confirmacion email
	// *************************************
	/**
	 * Method 'getCreateFormConfirmacionEMail'.
	 * 
	 * @param model
	 *            Model
	 * @return String
	 */
	@RequestMapping(value = "confirmacionEmail", method = RequestMethod.GET)
	public ModelAndView getCreateFormConfirmacionEMail(Model model) {
		model.addAttribute("defaultLanguage",
				appConfiguration.get("y38aAppWar.default.language"));
		model.addAttribute("defaultLayout",
				appConfiguration.get("y38aAppWar.default.layout"));

		model.addAttribute("statics_path",
				this.appConfiguration.get("statics.path"));

		return new ModelAndView("confirmacionEmail", "model", model);

	}

	// **************************************
	// pruebas confirmacion email error
	// *************************************
	/**
	 * Method 'getCreateFormConfirmacionEMail'.
	 * 
	 * @param model
	 *            Model
	 * @return String
	 */
	@RequestMapping(value = "confirmacionEmailError", method = RequestMethod.GET)
	public ModelAndView getCreateFormConfirmacionEMailError(Model model) {
		model.addAttribute("defaultLanguage",
				appConfiguration.get("y38aAppWar.default.language"));
		model.addAttribute("defaultLayout",
				appConfiguration.get("y38aAppWar.default.layout"));

		model.addAttribute("statics_path",
				this.appConfiguration.get("statics.path"));

		return new ModelAndView("confirmacionEmailError", "model", model);

	}

	// ******************************************
	// ******************************************

	/**
	 * Method 'getCreateForm'.
	 * 
	 * @param model
	 *            Model
	 * @return String
	 */

	@RequestMapping(value = "result", method = RequestMethod.GET)
	public ModelAndView getCreateForm6(Model model) {

		model.addAttribute("defaultLanguage",
				appConfiguration.get("y38aAppWar.default.language"));
		model.addAttribute("defaultLayout",
				appConfiguration.get("y38aAppWar.default.layout"));

		model.addAttribute("statics_path",
				this.appConfiguration.get("statics.path"));

		return new ModelAndView("result", "model", model);

	}

	/**
	 * Method 'getCreateForm'.
	 * 
	 * @param model
	 *            Model
	 * @return String
	 */
	@RequestMapping(value = "detalle", method = RequestMethod.GET)
	public ModelAndView getCreateForm4(Model model) {
		model.addAttribute("defaultLanguage",
				appConfiguration.get("y38aAppWar.default.language"));
		model.addAttribute("defaultLayout",
				appConfiguration.get("y38aAppWar.default.layout"));

		model.addAttribute("statics_path",
				this.appConfiguration.get("statics.path"));

		return new ModelAndView("detalle", "model", model);

	}

	/**
	 * Method 'getCreateForm'. 658206
	 * 
	 * @param model
	 *            Model
	 * @return String
	 */
	@RequestMapping(value = "detalleDistintivo", method = RequestMethod.GET)
	public ModelAndView getCreateForm5(Model model) {
		model.addAttribute("defaultLanguage",
				appConfiguration.get("y38aAppWar.default.language"));
		model.addAttribute("defaultLayout",
				appConfiguration.get("y38aAppWar.default.layout"));

		model.addAttribute("statics_path",
				this.appConfiguration.get("statics.path"));

		return new ModelAndView("detalleDistintivo", "model", model);

	}

	/**
	 * Method 'getByDistId'.
	 * 
	 * @param esnif
	 *            String
	 * @param model
	 *            Model
	 * @return String
	 */
	@RequestMapping(value = "/distintivoMail/{escodigo}", method = RequestMethod.GET)
	public ModelAndView getByDistMailId(@PathVariable() String escodigo,
			Model model) {
		model.addAttribute("defaultLanguage",
				this.appConfiguration.get("y38aAppWar.default.language"));
		model.addAttribute("defaultLayout",
				this.appConfiguration.get("y38aAppWar.default.layout"));

		// Locale locale = LocaleContextHolder.getLocale();
		Establec establec = new Establec();
		Establec establecDef = new Establec();
		try {
			establec.setEscodigo(escodigo);

			List<Establec> establecLis = this.establecService
					.findAllLikeEstablec(establec, null, false);

			if (establecLis == null || establecLis.size() == 0) {
				throw new Exception(escodigo.toString());
			}
			establecDef = establecLis.get(0);
			this.setFormalizacion(establecDef);

		} catch (Exception e) {
			throw new ResourceNotFoundException(escodigo.toString());
		}

		model.addAttribute("establec", establecDef);
		// EstablecController.logger.debug("controler   /app/mant/contactos");
		model.addAttribute("statics_path",
				this.appConfiguration.get("statics.path"));
		model.addAttribute("URL_BUSQUEDA_EMPRESAS",
				this.appConfiguration.get("URL_BUSQUEDA_EMPRESAS"));

		return new ModelAndView("detalleDistintivoMail", "model", model);
	}

	/**
	 * Method 'getById'.
	 * 
	 * @param escodigo
	 *            String
	 * @return String
	 */
	@RequestMapping(value = "/{escodigo}", method = RequestMethod.GET)
	public @ResponseBody
	Establec getById(@PathVariable String escodigo) {
		try {
			Establec establec = new Establec();
			establec.setEscodigo(escodigo);
			establec = this.establecService.find(establec);
			if (establec == null) {
				throw new Exception(escodigo.toString());
			}
			return establec;
		} catch (Exception e) {
			throw new ResourceNotFoundException(escodigo.toString());
		}
	}

	/**
	 * Method 'getById'.
	 * 
	 * @param escodigo
	 *            String
	 * @return String
	 */
	@RequestMapping(value = "/getByIdEstablecimieto/{escodigo}", method = RequestMethod.GET)
	public @ResponseBody
	Establec getByIdEstablecimietnp(@PathVariable String escodigo) {
		try {
			Establec establec = new Establec();
			establec.setEscodigo(escodigo);
			establec = this.establecService.findEstablecimiento(establec);
			if (establec == null) {
				throw new Exception(escodigo.toString());
			}
			return establec;
		} catch (Exception e) {
			throw new ResourceNotFoundException(escodigo.toString());
		}
	}

	/**
	 * Method 'getByEsnif'.
	 * 
	 * @param esnif
	 *            String
	 * @return String
	 */
	@ResponseBody()
	@RequestMapping(value = "/nif", method = RequestMethod.GET)
	public Object establec(
			@RequestParam(value = "esnif", required = false) String esnif,
			HttpServletRequest request) {

		Establec establec = new Establec();
		Establec establecDef = new Establec();
		List<Establec> establecLis;
		try {
			establec.setEsnif(esnif);
			establec.setEsinadar("S");

			Pagination pagination = null;
			if (request.getHeader("JQGridModel") != null
					&& request.getHeader("JQGridModel").equals("true")) {
				pagination = new Pagination();
				pagination.setPage(Long.valueOf(request.getParameter("page")));
				pagination.setRows(Long.valueOf(request.getParameter("rows")));
				pagination.setSort(request.getParameter("sidx"));
				pagination.setAscDsc(request.getParameter("sord"));
				establecLis = this.establecService
						.findAllLikeEstablecDistintivo(establec, pagination,
								false);

				if (establecLis == null) {
					throw new Exception("No data Found.");
				}

				if (establecLis == null || establecLis.size() == 0) {
					this.setFormalizacion(establec);
					establecLis.set(0, establec);
				} else {
					for (int i = 0; i < establecLis.size(); i++) {
						establecDef = establecLis.get(i);
						this.setFormalizacion(establecDef);
						establecLis.set(i, establecDef);
					}
				}

				Long total = this.establecService
						.findAllCountLikeEstablecDistintivo(establec);
				JQGridJSONModel data = new JQGridJSONModel();
				data.setPage(request.getParameter("page"));
				data.setRecords(total.intValue());
				data.setTotal(total, pagination.getRows());
				data.setRows(establecLis);
				return data;
			} else {
				establecLis = this.establecService
						.findAllLikeEstablecDistintivo(establec, null, false);

				if (establecLis == null || establecLis.size() == 0) {
					this.setFormalizacion(establec);
					establecLis.set(0, establec);
				}

			}
		} catch (Exception e) {
			throw new ResourceNotFoundException(esnif.toString());
		}
		return establecLis;
	}

	/**
	 * Method 'findAllCountLikeEstablec'.
	 * 
	 * @param esnif
	 *            String
	 * @return String
	 */
	@ResponseBody()
	@RequestMapping(value = "/nifCount", method = RequestMethod.GET)
	public long establecCount(
			@RequestParam(value = "esnif", required = false) String esnif) {

		Establec establec = new Establec();
		long establecLis;
		try {
			establec.setEsnif(esnif);
			establec.setEsinadar("S");

			establecLis = this.establecService
					.findAllCountLikeEstablecDistintivo(establec);
		} catch (Exception e) {
			throw new ResourceNotFoundException(esnif.toString());
		}
		return establecLis;
	}

	/**
	 * Method 'getByDistId'.
	 * 
	 * @param escodigo
	 *            String
	 * @param model
	 *            Model
	 * @return String
	 */
	@RequestMapping(value = "/distintivo", method = RequestMethod.GET)
	public ModelAndView getByDistId(
			@RequestParam(value = "escodigo", required = false) String escodigo,
			Model model) {
		model.addAttribute("defaultLanguage",
				this.appConfiguration.get("y38aAppWar.default.language"));
		model.addAttribute("defaultLayout",
				this.appConfiguration.get("y38aAppWar.default.layout"));

		// Locale locale = LocaleContextHolder.getLocale();
		Establec establec = new Establec();
		Establec establecDef = new Establec();

		try {
			establec.setEscodigo(escodigo);

			List<Establec> establecLis = this.establecService
					.findAllLikeEstablec(establec, null, false);

			if (establecLis == null || establecLis.size() == 0) {
				throw new Exception(escodigo.toString());
			}
			establecDef = establecLis.get(0);
			this.setFormalizacion(establecDef);

		} catch (Exception e) {
			throw new ResourceNotFoundException(escodigo.toString());
		}

		model.addAttribute("establec", establecDef);
		// EstablecController.logger.debug("controler   /app/mant/contactos");
		model.addAttribute("URL_BUSQUEDA_EMPRESAS",
				this.appConfiguration.get("URL_BUSQUEDA_EMPRESAS"));
		model.addAttribute("URL_LOGOTIPO",
				this.appConfiguration.get("URL_LOGOTIPO"));

		return new ModelAndView("detalleDistintivo", "model", model);
	}

	/**
	 * Method 'getAll'.
	 * 
	 * @param escodigo
	 *            String
	 * @param esnombre_
	 *            String
	 * @param esnif
	 *            String
	 * @param esnoan
	 *            String
	 * @param esnoco
	 *            String
	 * @param esnodir
	 *            String
	 * @param escolo
	 *            String
	 * @param esnrcopo
	 *            String
	 * @param esnrtel
	 *            String
	 * @param esnrfax
	 *            String
	 * @param escopa
	 *            String
	 * @param esincapr
	 *            String
	 * @param esindemp
	 *            String
	 * @param esteco
	 *            String
	 * @param esinadar_
	 *            String
	 * @param esfeadar
	 *            Date
	 * @param escoem
	 *            String
	 * @param esinempr
	 *            String
	 * @param esnrtel2
	 *            String
	 * @param esfeba
	 *            Date
	 * @param esnoap1
	 *            String
	 * @param esnoap2
	 *            String
	 * @param esnolo_
	 *            String
	 * @param escomapv
	 *            String
	 * @param escoca
	 *            String
	 * @param esnopeco_
	 *            String
	 * @param escoidco
	 *            String
	 * @param esinreco
	 *            String
	 * @param escozs
	 *            String
	 * @param esfemod
	 *            String
	 * @param esinesco
	 *            String
	 * @param esnomu
	 *            String
	 * @param esnorep
	 *            String
	 * @param esnifrep
	 *            String
	 * @param dtteemr
	 *            String
	 * @param escarep
	 *            String
	 * @param esteurl
	 *            String
	 * @param escooe
	 *            String
	 * @param esnodeco
	 *            String
	 * @param esintiar
	 *            String
	 * @param esfeplad
	 *            Date
	 * @param esindeme
	 *            String
	 * @param eslocalidad_
	 *            String
	 * @param esmunicipio
	 *            String
	 * @param esprovincia
	 *            String
	 * @param ahfeba
	 *            Date
	 * @param codsector_
	 *            String
	 * @param localizacion_
	 *            String
	 * @param limitaciones
	 *            String
	 * @param numregadhesion_
	 *            String
	 * 
	 * @param request
	 *            HttpServletRequest
	 * @return String
	 */
	@RequestMapping(method = RequestMethod.GET)
	public @ResponseBody
	Object getAll(
			@RequestParam(value = "escodigo", required = false) String escodigo,
			@RequestParam(value = "esnombre", required = false) String esnombre_,
			@RequestParam(value = "esnif", required = false) String esnif_,
			@RequestParam(value = "esnoan", required = false) String esnoan,
			@RequestParam(value = "esnoco", required = false) String esnoco,
			@RequestParam(value = "esnodir", required = false) String esnodir,
			@RequestParam(value = "escolo", required = false) String escolo,
			@RequestParam(value = "esnrcopo", required = false) String esnrcopo,
			@RequestParam(value = "esnrtel", required = false) String esnrtel,
			@RequestParam(value = "esnrfax", required = false) String esnrfax,
			@RequestParam(value = "escopa", required = false) String escopa,
			@RequestParam(value = "esincapr", required = false) String esincapr,
			@RequestParam(value = "esindemp", required = false) String esindemp,
			@RequestParam(value = "esteco", required = false) String esteco,
			@RequestParam(value = "esinadar", required = false) String esinadar_,
			@RequestParam(value = "esfeadar", required = false) Date esfeadar,
			@RequestParam(value = "escoem", required = false) String escoem,
			@RequestParam(value = "esinempr", required = false) String esinempr,
			@RequestParam(value = "esnrtel2", required = false) String esnrtel2,
			@RequestParam(value = "esfeba", required = false) Date esfeba,
			@RequestParam(value = "esnoap1", required = false) String esnoap1,
			@RequestParam(value = "esnoap2", required = false) String esnoap2,
			@RequestParam(value = "esnolo", required = false) String esnolo_,
			@RequestParam(value = "escomapv", required = false) String escomapv,
			@RequestParam(value = "escoca", required = false) String escoca,
			@RequestParam(value = "esnopeco", required = false) String esnopeco_,
			@RequestParam(value = "escoidco", required = false) String escoidco,
			@RequestParam(value = "esinreco", required = false) String esinreco,
			@RequestParam(value = "escozs", required = false) String escozs,
			@RequestParam(value = "esfemod", required = false) String esfemod,
			@RequestParam(value = "esinesco", required = false) String esinesco,
			@RequestParam(value = "esnomu", required = false) String esnomu,
			@RequestParam(value = "esnorep", required = false) String esnorep,
			@RequestParam(value = "esnifrep", required = false) String esnifrep,
			@RequestParam(value = "dtteemr", required = false) String dtteemr,
			@RequestParam(value = "escarep", required = false) String escarep,
			@RequestParam(value = "esteurl", required = false) String esteurl,
			@RequestParam(value = "escooe", required = false) String escooe,
			@RequestParam(value = "esnodeco", required = false) String esnodeco,
			@RequestParam(value = "esintiar", required = false) String esintiar,
			@RequestParam(value = "esfeplad", required = false) Date esfeplad,
			@RequestParam(value = "esindeme", required = false) String esindeme,
			@RequestParam(value = "eslocalidad", required = false) String eslocalidad_,
			@RequestParam(value = "esmunicipio", required = false) String esmunicipio,
			@RequestParam(value = "esprovincia", required = false) String esprovincia,
			@RequestParam(value = "ahfeba", required = false) Date ahfeba,
			@RequestParam(value = "codsector", required = false) String codsector_,
			@RequestParam(value = "localizacion", required = false) String localizacion_,
			@RequestParam(value = "limitaciones", required = false) String limitaciones,

			@RequestParam(value = "esextranjero", required = false) String esextranjero_,
			@RequestParam(value = "esnoraProvinciaId", required = false) String esnoraProvinciaId_,
			@RequestParam(value = "esnoraMunicipioId", required = false) String esnoraMunicipioId_,
			@RequestParam(value = "esnoraLocalidadId", required = false) String esnoraLocalidadId_,
			@RequestParam(value = "esnoraPaisId", required = false) String esnoraPaisId_,

			@RequestParam(value = "numregadhesion", required = false) String numregadhesion_,

			HttpServletRequest request) {
		try {

			// control nora nuevo
			String esextranjero = "";
			String esestado = "";
			String esnoraPaisId = "";
			String esnoraProvinciaId = "";
			String esnoraMunicipioId = "";
			String esnoraLocalidadId = "";

			if (Y38aEstablecAdheConstantes.NORA_LOCALIZACION_TODOS
					.equals(esextranjero_)) { // T
				esextranjero = null;
				esestado = null;
				esnoraPaisId = null;
				esnoraProvinciaId = null;
				esnoraMunicipioId = null;
				esnoraLocalidadId = null;
			} else if (Y38aEstablecAdheConstantes.NORA_LOCALIZACION_EXTRANJERO // X
					.equals(esextranjero_)) {
				esextranjero = Y38aEstablecAdheConstantes.SI;
				esestado = null;
				esnoraPaisId = ("".equals(esnoraPaisId_)) ? null
						: esnoraPaisId_;
				esnoraProvinciaId = null;
				esnoraMunicipioId = null;
				esnoraLocalidadId = null;
			} else { // E
				esextranjero = null;
				esnoraPaisId = null;
				esestado = Y38aEstablecAdheConstantes.NORA_LOCALIZACION_ESTADO;
				esnoraProvinciaId = ("".equals(esnoraProvinciaId_)) ? null
						: esnoraProvinciaId_;
				esnoraMunicipioId = ("".equals(esnoraMunicipioId_)) ? null
						: esnoraMunicipioId_;
				esnoraLocalidadId = ("".equals(esnoraLocalidadId_)) ? null
						: esnoraLocalidadId_;
			}

			String esnombre = ("".equals(esnombre_)) ? null : esnombre_;

			logger.info("##############ANTES REEMPLAZO[" + esnombre + "]");
			if (esnombre != null) {
				esnombre = this.setConversion(esnombre);
			}

			logger.info("##############DESPUES REEMPLAZO[" + esnombre + "]");

			String esnif = ("".equals(esnif_)) ? null : esnif_;

			if (esnif != null) {
				esnif = this.setConversion(esnif);
			}

			String numregadhesion = ("".equals(numregadhesion_)) ? null
					: numregadhesion_;

			if (numregadhesion != null) {
				numregadhesion = this.setConversion(numregadhesion);
			}

			String esinadar = ("".equals(esinadar_)) ? null : esinadar_;

			String esnopeco = ("".equals(esnopeco_)) ? null : esnopeco_;

			if ((Y38aEstablecAdheConstantes.ON).equals(esinadar_)
					&& null == esnopeco) {
				esinadar = Y38aEstablecAdheConstantes.SI;
			}
			if ((Y38aEstablecAdheConstantes.ON).equals(esnopeco_)
					&& null == esinadar) {
				esinadar = Y38aEstablecAdheConstantes.NO;
			}
			if ((Y38aEstablecAdheConstantes.ON).equals(esnopeco_)
					&& (Y38aEstablecAdheConstantes.ON).equals(esinadar_)) {
				esinadar = null;
			}

			String codsector = "";
			try {
				codsector = ("".equals(codsector_)) ? null : codsector_;

				if (Y38aUtils.isValid(codsector)) {
					int tope = (codsector.length()) - 1;
					codsector = codsector.substring(0, tope);
				}

			} catch (Exception e) {
				e.printStackTrace();
			}

			logger.info("!!!!!!!!!!!!!!!esnombre!!!!!!!!!!!!" + esnombre);

			String localizacion = localizacion_;

			String esnolo = null;
			Establec filterEstablec = new Establec(escodigo, esnombre, esnif,
					esnoan, esnoco, esnodir, escolo, esnrcopo, esnrtel,
					esnrfax, escopa, esincapr, esindemp, esteco, esinadar,
					esfeadar, escoem, esinempr, esnrtel2, esfeba, esnoap1,
					esnoap2, esnolo, escomapv, escoca, esnopeco, escoidco,
					esinreco, escozs, esfemod, esinesco, esnomu, esnorep,
					esnifrep, dtteemr, escarep, esteurl, escooe, esnodeco,
					esintiar, esfeplad, esindeme, null, null, null, ahfeba,
					codsector, localizacion, limitaciones, esextranjero,
					esestado, esnoraPaisId, null, esnoraProvinciaId, null,
					esnoraMunicipioId, null, esnoraLocalidadId, null, null,
					null, null, null, null, null, null, null, numregadhesion);

			Pagination pagination = null;
			if (request.getHeader("JQGridModel") != null
					&& request.getHeader("JQGridModel").equals("true")) {
				pagination = new Pagination();
				pagination.setPage(Long.valueOf(request.getParameter("page")));
				pagination.setRows(Long.valueOf(request.getParameter("rows")));
				pagination.setSort(request.getParameter("sidx"));
				pagination.setAscDsc(request.getParameter("sord"));
				List<Establec> establecs = this.establecService
						.findAllLikeEstablec(filterEstablec, pagination, false);

				if (establecs == null) {
					throw new Exception("No data Found.");
				}

				// for (Establec establec : establecs) {
				// this.setFormalizacion(establec);
				// }

				Long total = this.establecService
						.findAllCountLikeEstablec(filterEstablec);
				JQGridJSONModel data = new JQGridJSONModel();
				data.setPage(request.getParameter("page"));
				data.setRecords(total.intValue());
				data.setTotal(total, pagination.getRows());
				data.setRows(establecs);
				return data;
			} else {
				List<Establec> establecs = this.establecService
						.findAllLikeEstablec(filterEstablec, pagination, false);
				if (establecs == null) {
					throw new Exception("No data Found.");
				}
				// for (Establec establec : establecs) {
				// this.setFormalizacion(establec);
				// }

				return establecs;
			}
		} catch (Exception e) {
			e.printStackTrace();
			throw new ResourceNotFoundException("No data Found.");
		}
	}

	/**
	 * Method 'getAllCount'.
	 * 
	 * @param filterEstablec
	 *            Establec
	 * @param request
	 *            HttpServletRequest
	 * @return Long
	 */
	@RequestMapping(value = "/count", method = RequestMethod.GET)
	public @ResponseBody
	Long getAllCount(
			@RequestParam(value = "establec", required = false) Establec filterEstablec,
			HttpServletRequest request) {
		try {
			return establecService
					.findAllCount(filterEstablec != null ? filterEstablec
							: new Establec());
		} catch (Exception e) {
			throw new ServiceUnavailableException(
					"Count Service is not responding.");
		}
	}

	/**
	 * Method 'edit'.
	 * 
	 * @param establec
	 *            Establec
	 * @param response
	 *            HttpServletResponse
	 * @return Establec
	 */
	@RequestMapping(method = RequestMethod.PUT)
	public @ResponseBody
	Establec edit(@RequestBody Establec establec, HttpServletResponse response) {
		try {
			Establec establecAux = this.establecService.update(establec);
			logger.info("Entity correctly inserted!");
			return establecAux;
		} catch (Exception e) {
			throw new MethodFailureException("Method failed");
		}
	}

	// /////////////////////////////////////

	/**
	 * Method 'envioMensage'.
	 * 
	 * @param escodigo
	 *            String
	 * @param response
	 *            HttpServletRequest
	 * @return
	 */
	@RequestMapping(value = "/envioMensage")
	public @ResponseBody()
	void envioMensage(
			@RequestParam(value = "escodigo", required = false) String escodigo,
			HttpServletResponse response) {

		Establec establec = new Establec();
		Establec establecDef = new Establec();
		try {
			establec.setEscodigo(escodigo);

			List<Establec> establecLis = this.establecService
					.findAllLikeEstablec(establec, null, false);

			if (establecLis == null || establecLis.size() == 0) {
				throw new Exception(escodigo.toString());
			}

			if (establecLis.size() > 0) {
				establecDef = establecLis.get(0);
				this.setFormalizacion(establecDef);
			}
			this.establecService.emailSolicitudDistintivo(establecDef);
			response.setStatus(HttpServletResponse.SC_OK);
		} catch (Exception e) {
			EstablecController.logger.error("Unable to envioMensage "
					+ escodigo);
			response.setStatus(HttpServletResponse.SC_BAD_REQUEST);
			throw new MethodFailureException(escodigo.toString());
		}

	}

	// /////////////////////////////////////
	/**
	 * Method 'add'.
	 * 
	 * @param establec
	 *            Establec
	 * @return Establec
	 */
	@RequestMapping(method = RequestMethod.POST)
	public @ResponseBody
	Establec add(@RequestBody Establec establec) {
		try {
			Establec establecAux = this.establecService.add(establec);
			logger.info("Entity correctly inserted!");
			return establecAux;
		} catch (Exception e) {
			throw new MethodFailureException("Method failed");
		}
	}

	/**
	 * Method 'remove'.
	 * 
	 * @param escodigo
	 *            String
	 * @param response
	 *            HttpServletResponse
	 * @return
	 */
	@RequestMapping(value = "/{escodigo}", method = RequestMethod.DELETE)
	public void remove(@PathVariable String escodigo,
			HttpServletResponse response) {
		response.setContentType("text/javascript;charset=utf-8");
		response.setHeader("Pragma", "cache");
		response.setHeader("Expires", "0");
		response.setHeader("Cache-Control", "private");
		try {
			Establec establec = new Establec();
			establec.setEscodigo(escodigo);
			this.establecService.remove(establec);
			response.setStatus(HttpServletResponse.SC_OK);
		} catch (Exception e) {
			logger.error("Unable to delete " + escodigo);
			response.setStatus(HttpServletResponse.SC_BAD_REQUEST);
			throw new MethodFailureException("Method failed");
		}
	}

	/**
	 * Method 'removeAll'.
	 * 
	 * @param establecIds
	 *            ArrayList
	 * @param response
	 *            HttpServletResponse
	 * @return
	 */
	@RequestMapping(value = "/deleteAll", method = RequestMethod.POST)
	public void removeMultiple(
			@RequestBody ArrayList<ArrayList<String>> establecIds,
			HttpServletResponse response) {
		response.setContentType("text/javascript;charset=utf-8");
		response.setHeader("Pragma", "cache");
		response.setHeader("Expires", "0");
		response.setHeader("Cache-Control", "private");
		ArrayList<Establec> establecList = new ArrayList<Establec>();
		try {
			for (ArrayList<String> establecId : establecIds) {
				Iterator<String> iterator = establecId.iterator();
				Establec establec = new Establec();// NOPMD
				establec.setEscodigo(ObjectConversionManager.convert(
						iterator.next(), String.class));
				establecList.add(establec);
			}
			this.establecService.removeMultiple(establecList);
			response.setStatus(HttpServletResponse.SC_OK);
		} catch (Exception e) {
			response.setStatus(HttpServletResponse.SC_BAD_REQUEST);
			throw new MethodFailureException("Method failed");
		}
	}

	/**
	 * Method 'handle'.
	 * 
	 * @param e
	 *            ControlException
	 * @return String
	 */
	@ExceptionHandler
	public @ResponseBody
	String handle(ControlException e) {
		logger.warn(e.getMessage());
		return e.getMessage();
	}

	/**
	 * Method 'getEstablecService'.
	 * 
	 * @return EstablecService
	 */
	protected EstablecService getEstablecService() {
		return this.establecService;
	}

	/**
	 * Method 'setEstablecService'.
	 * 
	 * @param establecService
	 *            EstablecService
	 * @return
	 */
	public void setEstablecService(EstablecService establecService) {
		this.establecService = establecService;
	}

	/**
	 * Method 'getAppConfiguration'.
	 * 
	 * @return appConfiguration
	 */
	public Properties getAppConfiguration() {
		return appConfiguration;
	}

	/**
	 * Method 'setAppConfiguration'.
	 * 
	 * @param appConfiguration
	 *            Properties
	 * @return
	 */
	public void setAppConfiguration(Properties appConfiguration) {
		this.appConfiguration = appConfiguration;
	}

	/**
	 * Establece la localizacion del establecimiento
	 * 
	 * @param establec
	 *            Establec
	 */
	private void setFormalizacion(Establec establec) {
		StringBuffer localizacion = new StringBuffer(
				Y38aEstablecAdheConstantes.NUM_3000);

		if (Y38aEstablecAdheConstantes.SI.equals(establec.getEsextranjero())) {
			localizacion.append(establec.getEsdireccion_nocapv()).append(", ")
					.append(establec.getEsnoraPaisNombre()).append(" (")
					.append(establec.getEsnombreCp()).append(")");
		} else {
			if (Y38aEstablecAdheConstantes.BIZKAIA.equals(establec
					.getEsnoraProvinciaId())
					|| Y38aEstablecAdheConstantes.GIPUZKOA.equals(establec
							.getEsnoraProvinciaId())
					|| Y38aEstablecAdheConstantes.ALAVA.equals(establec
							.getEsnoraProvinciaId())) {
				if (Y38aUtils.isFilled(establec.getEsnombreCalle())) {
					localizacion.append(establec.getEsnombreCalle());
				}
				localizacion.append(" ");

				if (Y38aUtils.isFilled(establec.getEsnombrePortal())) {
					localizacion.append(establec.getEsnombrePortal());
				}
				localizacion.append(" ");

				if (Y38aUtils.isFilled(establec.getEsnombrePiso())) {
					localizacion.append(establec.getEsnombrePiso());
				}
				localizacion.append(" ");

				if (Y38aUtils.isFilled(establec.getEsdireccion_nocapv())) {
					localizacion.append(establec.getEsdireccion_nocapv());
				}
				localizacion.append(", ");

				if (Y38aUtils.isFilled(establec.getEsnombreMunicipio())) {
					localizacion.append(establec.getEsnombreMunicipio());
				}
				localizacion.append(", ");

				if (Y38aUtils.isFilled(establec.getEsnombreProvincia())) {
					localizacion.append(establec.getEsnombreProvincia());
				}
				localizacion.append(" (");

				if (Y38aUtils.isFilled(establec.getEsnombreCp())) {
					localizacion.append(establec.getEsnombreCp());
				}
				localizacion.append(")");
			} else {
				if (Y38aUtils.isFilled(establec.getEsdireccion_nocapv())) {
					localizacion.append(establec.getEsdireccion_nocapv());
				}
				localizacion.append(", ");

				if (Y38aUtils.isFilled(establec.getEsnombreMunicipio())) {
					localizacion.append(establec.getEsnombreMunicipio());
				}
				localizacion.append(", ");

				if (Y38aUtils.isFilled(establec.getEsnombreProvincia())) {
					localizacion.append(establec.getEsnombreProvincia());
				}
				localizacion.append(" (");

				if (Y38aUtils.isFilled(establec.getEsnombreCp())) {
					localizacion.append(establec.getEsnombreCp());
				}
				localizacion.append(")");
			}
		}

		establec.setLocalizacion(localizacion.toString());

		if ("null".equals(establec.getEsnombre())
				|| null == establec.getEsnombre()) {
			establec.setEsnombre("");
		}
		if ("null".equals(establec.getEsnoco()) || null == establec.getEsnoco()) {
			establec.setEsnoco("");
		}
		if ("null".equals(establec.getEsnif()) || null == establec.getEsnif()) {
			establec.setEsnif("");
		}
		if ("null".equals(establec.getEsnodir())
				|| null == establec.getEsnodir()) {
			establec.setEsnodir("");
		}
		if ("null".equals(establec.getEsnrcopo())
				|| null == establec.getEsnrcopo()) {
			establec.setEsnrcopo("");
		}
		if ("null".equals(establec.getLocalizacion())
				|| null == establec.getLocalizacion()) {
			establec.setLocalizacion("");
		}
		if ("null".equals(establec.getEsnrtel())
				|| null == establec.getEsnrtel()) {
			establec.setEsnrtel("");
		}
		if ("null".equals(establec.getEsnrfax())
				|| null == establec.getEsnrfax()) {
			establec.setEsnrfax("");
		}
		if ("null".equals(establec.getLimitaciones())
				|| null == establec.getLimitaciones()) {
			establec.setLimitaciones("");
		}

		if ("null".equals(establec.getDtteemr())
				|| null == establec.getDtteemr()) {
			establec.setDtteemr("");
		}
		if ("null".equals(establec.getEsteurl())
				|| null == establec.getEsteurl()) {
			establec.setEsteurl("");
		}
		if ("null".equals(establec.getEscoem()) || null == establec.getEscoem()) {
			establec.setEscoem("");
		}
		if ("null".equals(establec.getEsteco()) || null == establec.getEsteco()) {
			establec.setEsteco("");
		}

		/*
		 * establec.setEsfeadar(Y38aUtils.formatearStringToDateFormato((establec
		 * .getEsfeadar().toString()).replace("-", "/")));
		 * 
		 * if ("null".equals(establec.getEsfeba()) || null ==
		 * establec.getEsfeba()) { establec.getEsfeba(); } else {
		 * establec.setEsfeba(Y38aUtils.formatearStringToDateFormato((establec
		 * .getEsfeba().toString()).replace("-", "/"))); }
		 */

	}

	/**
	 * Conversión datos recibidos
	 * 
	 * @param texto
	 *            String
	 * 
	 * @return String
	 */
	private String setConversion(String texto) {

		texto = texto.replaceAll("%25", "%");

		texto = texto.replaceAll("%20", " ");
		texto = texto.replaceAll("%F1", "\u00f1");
		texto = texto.replaceAll("%D1", "\u00d1");

		texto = texto.replaceAll("%E1", "a");
		texto = texto.replaceAll("%E9", "e");
		texto = texto.replaceAll("%ED", "i");
		texto = texto.replaceAll("%F3", "o");
		texto = texto.replaceAll("%FA", "u");

		texto = texto.replaceAll("%C1", "A");
		texto = texto.replaceAll("%C9", "E");
		texto = texto.replaceAll("%CD", "I");
		texto = texto.replaceAll("%D3", "O");
		texto = texto.replaceAll("%DA", "U");

		texto = texto.replaceAll("%BA", "\u00ba");
		texto = texto.replaceAll("%AA", "\u00aa");

		texto = texto.replaceAll("%26", "&");

		texto = texto.replaceAll("%B4", "\u00b4");

		texto = texto.replaceAll("%22", "\"");

		texto = texto.replaceAll("%2C", ",");

		texto = texto.replaceAll("%27", "'");

		texto = texto.replaceAll("%60", "`");

		texto = texto.replaceAll("%21", "!");

		texto = texto.replaceAll("%A1", "\u00a1");

		texto = texto.replaceAll("%B7", "\u00b7");

		texto = texto.replaceAll("%28", "(");

		texto = texto.replaceAll("%29", ")");

		texto = texto.replaceAll("%3D", "=");

		texto = texto.replaceAll("%3F", "?");

		texto = texto.replaceAll("%BF", "\u00bf");

		texto = texto.replaceAll("%E7", "\u00e7");

		texto = texto.replaceAll("%3B", ";");

		texto = texto.replaceAll("%3A", ":");

		texto = texto.trim();

		return texto;
	}
}
