package com.ejie.y38a.dao;

import com.ejie.x38.dto.Pagination;
import java.util.List;

import com.ejie.y38a.model.Adheesta;

/**
 *  * AdheestaDao  
 *  
 */

public interface AdheestaDao {
    
    /**
     * Inserts a single row in the Adheesta table.
     *
     * @param adheesta Adheesta
     * @return Adheesta
     */
    Adheesta add(Adheesta adheesta);

    /**
     * Updates a single row in the Adheesta table.
     *
     * @param adheesta Adheesta
     * @return Adheesta
     */
    Adheesta update(Adheesta adheesta);

    /**
     * Finds a single row in the Adheesta table.
     *
     * @param adheesta Adheesta
     * @return Adheesta
     */
    Adheesta find(Adheesta adheesta);

    /**
     * Deletes a single row in the Adheesta table.
     *
     * @param adheesta Adheesta
     * @return 
     */
    void remove(Adheesta adheesta);

    /**
     * Finds a List of rows in the Adheesta table.
     *
     * @param adheesta Adheesta
     * @param pagination Pagination
     * @return List
     */
    List<Adheesta> findAll(Adheesta adheesta, Pagination pagination);

    /**
     * Counts rows in the Adheesta table.
     *
     * @param adheesta Adheesta
     * @return List
     */
    Long findAllCount(Adheesta adheesta);
	
	/**
     * Finds rows in the Adheesta table using like.
     *
     * @param adheesta Adheesta
     * @param pagination Pagination
     * @param startsWith Boolean
     * @return List
     */
	List<Adheesta> findAllLike(Adheesta adheesta, Pagination pagination, Boolean startsWith);
}

