package com.ejie.y38a.dao;

import com.ejie.x38.dto.Pagination;
import com.ejie.x38.util.PaginationManager;
import com.ejie.y38a.constantes.Y38aEstablecAdheConstantes;
import com.ejie.y38a.model.Establec;
import com.ejie.y38a.model.Secagrup;
import com.ejie.y38a.model.Sectores;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import javax.annotation.Resource;
import javax.sql.DataSource;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.jdbc.core.simple.SimpleJdbcTemplate;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.y38a.model.Adheesta;

/**
 * * AdheestaDaoImpl  
 * 
 *  
 */

@Repository
@Transactional
public class AdheestaDaoImpl implements AdheestaDao {
	private SimpleJdbcTemplate jdbcTemplate;
	private RowMapper<Adheesta> rwMap = new RowMapper<Adheesta>() {
		public Adheesta mapRow(ResultSet resultSet, int rowNum)
				throws SQLException {
			return new Adheesta(resultSet.getString("AHCODIGO"), new Establec(
					resultSet.getString("ESCODIGO"), null, null, null, null,
					null, null, null, null, null, null, null, null, null, null,
					null, null, null, null, null, null, null, null, null, null,
					null, null, null, null, null, null, null, null, null, null,
					null, null, null, null, null, null, null, null, null, null,
					null, null, null, null, null, null, null, null, null, null,
					null, null, null, null, null, null, null, null, null, null,
					null, null, null), resultSet.getInt("AHCOEX"),
					resultSet.getInt("AHNRDI"), resultSet.getDate("AHFECODI"),
					resultSet.getDate("AHFEBA"),
					resultSet.getString("AHCOTAG"),
					resultSet.getString("AHCOT2"),
					resultSet.getString("AHCOAV"),
					resultSet.getString("AHCOSEDE"),
					resultSet.getDate("AHFEPUCD"),
					resultSet.getDate("AHFEPUBA"),
					resultSet.getString("AHCOCC"),
					resultSet.getString("AHNIREP"),
					resultSet.getString("AHNOREP"),
					resultSet.getString("AHNOAP1R"),
					resultSet.getString("AHNOAP2R"),
					resultSet.getString("AHNOCARE"),
					resultSet.getDate("AHFERE"),
					resultSet.getString("AHTELIMI"),
					resultSet.getString("AHINAMNA"),
					resultSet.getString("AHCOJA"),
					resultSet.getString("AHCOZS"),
					resultSet.getString("AHCOJAAD"), new Sectores(
							resultSet.getString("SectoresSECODIGO"),
							resultSet.getString("SectoresSENOMBRE"),
							resultSet.getString("SectoresSENOCO"),
							resultSet.getString("SectoresSEDESCRI"),
							resultSet.getString("SectoresSECOSE"),
							resultSet.getString("SectoresSENOCO2"),
							resultSet.getString("SectoresSEINSEL1"),
							resultSet.getString("SectoresSENOMBREE"),
							resultSet.getString("SectoresSENOMBREI"),
							resultSet.getString("SectoresSENOMBREF"),
							resultSet.getString("SectoresSENOCOE"),
							resultSet.getString("SectoresSENOCOI"),
							resultSet.getString("SectoresSENOCOF"),
							resultSet.getString("SectoresSEDESCRIE"),
							resultSet.getString("SectoresSEDESCRII"),
							resultSet.getString("SectoresSEDESCRIF"),
							resultSet.getString("SectoresSENOMBREA"),
							resultSet.getString("SectoresSEDESCRIA"),
							resultSet.getString("SectoresSENOCOA"),
							new Secagrup(resultSet.getString("SectoresSECOL0"),
									null, null, null, null, null, null),
							new Secagrup(resultSet
									.getString("SectoresSECODGRUPO"), null,
									null, null, null, null, null)));
		}
	};

	/**
	 * Method use to set the datasource.
	 * 
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	@Resource
	public void setDataSource(DataSource dataSource) {
		this.jdbcTemplate = new SimpleJdbcTemplate(dataSource);
	}

	/**
	 * Inserts a single row in the Adheesta table.
	 * 
	 * @param adheesta
	 *            Pagination
	 * @return Adheesta
	 */
	public Adheesta add(Adheesta adheesta) {

		String query = "INSERT INTO ADHEESTA( AHCODIGO,AHCOES,AHCOSE,AHCOEX,AHNRDI,AHFECODI,AHFEBA,AHCOTAG,AHCOT2,AHCOAV,AHCOSEDE,AHFEPUCD,AHFEPUBA,AHCOCC,AHNIREP,AHNOREP,AHNOAP1R,AHNOAP2R,AHNOCARE,AHFERE,AHTELIMI,AHINAMNA,AHCOJA,AHCOZS,AHCOJAAD)"
				+ "VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";

		Object EstablecEscodigoAux = null;
		if (adheesta.getEstablec() != null
				&& adheesta.getEstablec().getEscodigo() != null) {
			EstablecEscodigoAux = adheesta.getEstablec().getEscodigo();
		}
		Object getSectoresSecodigoAux = null;
		if (adheesta.getSectores() != null
				&& adheesta.getSectores().getSecodigo() != null) {
			getSectoresSecodigoAux = adheesta.getSectores().getSecodigo();
		}
		this.jdbcTemplate.update(query, adheesta.getAhcodigo(),
				EstablecEscodigoAux, getSectoresSecodigoAux,
				adheesta.getAhcoex(), adheesta.getAhnrdi(),
				adheesta.getAhfecodi(), adheesta.getAhfeba(),
				adheesta.getAhcotag(), adheesta.getAhcot2(),
				adheesta.getAhcoav(), adheesta.getAhcosede(),
				adheesta.getAhfepucd(), adheesta.getAhfepuba(),
				adheesta.getAhcocc(), adheesta.getAhnirep(),
				adheesta.getAhnorep(), adheesta.getAhnoap1r(),
				adheesta.getAhnoap2r(), adheesta.getAhnocare(),
				adheesta.getAhfere(), adheesta.getAhtelimi(),
				adheesta.getAhinamna(), adheesta.getAhcoja(),
				adheesta.getAhcozs(), adheesta.getAhcojaad());
		return adheesta;
	}

	/**
	 * Updates a single row in the Adheesta table.
	 * 
	 * @param adheesta
	 *            Pagination
	 * @return Adheesta
	 */
	public Adheesta update(Adheesta adheesta) {
		String query = "UPDATE ADHEESTA SET AHCOSE=?,AHCOEX=?,AHNRDI=?,AHFECODI=?,AHFEBA=?,AHCOTAG=?,AHCOT2=?,AHCOAV=?,AHCOSEDE=?,AHFEPUCD=?,AHFEPUBA=?,AHCOCC=?,AHNIREP=?,AHNOREP=?,AHNOAP1R=?,AHNOAP2R=?,AHNOCARE=?,AHFERE=?,AHTELIMI=?,AHINAMNA=?,AHCOJA=?,AHCOZS=?,AHCOJAAD=? WHERE AHCODIGO=? AND AHCOES=?";
		Object getSectoresSecodigoAux = null;
		if (adheesta.getSectores() != null
				&& adheesta.getSectores().getSecodigo() != null) {
			getSectoresSecodigoAux = adheesta.getSectores().getSecodigo();
		}
		Object EstablecEscodigoAux = null;
		if (adheesta.getEstablec() != null
				&& adheesta.getEstablec().getEscodigo() != null) {
			EstablecEscodigoAux = adheesta.getEstablec().getEscodigo();
		}
		this.jdbcTemplate.update(query, getSectoresSecodigoAux,
				adheesta.getAhcoex(), adheesta.getAhnrdi(),
				adheesta.getAhfecodi(), adheesta.getAhfeba(),
				adheesta.getAhcotag(), adheesta.getAhcot2(),
				adheesta.getAhcoav(), adheesta.getAhcosede(),
				adheesta.getAhfepucd(), adheesta.getAhfepuba(),
				adheesta.getAhcocc(), adheesta.getAhnirep(),
				adheesta.getAhnorep(), adheesta.getAhnoap1r(),
				adheesta.getAhnoap2r(), adheesta.getAhnocare(),
				adheesta.getAhfere(), adheesta.getAhtelimi(),
				adheesta.getAhinamna(), adheesta.getAhcoja(),
				adheesta.getAhcozs(), adheesta.getAhcojaad(),
				adheesta.getAhcodigo(), EstablecEscodigoAux);
		return adheesta;
	}

	/**
	 * Finds a single row in the Adheesta table.
	 * 
	 * @param adheesta
	 *            Pagination
	 * @return Adheesta
	 */
	@Transactional(readOnly = true)
	public Adheesta find(Adheesta adheesta) {
		String query = "SELECT t1.AHCODIGO AHCODIGO, t1.AHCOES AHCOES, t1.AHCOEX AHCOEX, t1.AHNRDI AHNRDI, t1.AHFECODI AHFECODI, t1.AHFEBA AHFEBA, t1.AHCOTAG AHCOTAG, t1.AHCOT2 AHCOT2, t1.AHCOAV AHCOAV, t1.AHCOSEDE AHCOSEDE, t1.AHFEPUCD AHFEPUCD, t1.AHFEPUBA AHFEPUBA, t1.AHCOCC AHCOCC, t1.AHNIREP AHNIREP, t1.AHNOREP AHNOREP, t1.AHNOAP1R AHNOAP1R, t1.AHNOAP2R AHNOAP2R, t1.AHNOCARE AHNOCARE, t1.AHFERE AHFERE, t1.AHTELIMI AHTELIMI, t1.AHINAMNA AHINAMNA, t1.AHCOJA AHCOJA, t1.AHCOZS AHCOZS, t1.AHCOJAAD AHCOJAAD, t2.SECODIGO SECTORESSECODIGO, t2.SENOMBRE SECTORESSENOMBRE, t2.SENOCO SECTORESSENOCO, t2.SEDESCRI SECTORESSEDESCRI, t2.SECOSE SECTORESSECOSE, t2.SENOCO2 SECTORESSENOCO2, t2.SEINSEL1 SECTORESSEINSEL1, t2.SENOMBREE SECTORESSENOMBREE, t2.SENOMBREI SECTORESSENOMBREI, t2.SENOMBREF SECTORESSENOMBREF, t2.SENOCOE SECTORESSENOCOE, t2.SENOCOI SECTORESSENOCOI, t2.SENOCOF SECTORESSENOCOF, t2.SEDESCRIE SECTORESSEDESCRIE, t2.SEDESCRII SECTORESSEDESCRII, t2.SEDESCRIF SECTORESSEDESCRIF, t2.SENOMBREA SECTORESSENOMBREA, t2.SEDESCRIA SECTORESSEDESCRIA, t2.SENOCOA SECTORESSENOCOA, t2.SECOL0 SECTORESSECOL0, t2.SECODGRUPO SECTORESSECODGRUPO "
				+ "FROM ADHEESTA t1 , SECTORES t2  "
				+ "WHERE t1.AHCODIGO = ?   AND t1.AHCOES = ?   AND t1.AHCOSE= t2.SECODIGO(+)  ";
		return (Adheesta) this.jdbcTemplate.queryForObject(query, rwMap,
				adheesta.getAhcodigo(), adheesta.getEstablec().getEscodigo());
	}

	/**
	 * Removes a single row in the Adheesta table.
	 * 
	 * @param adheesta
	 *            Pagination
	 * @return
	 */
	public void remove(Adheesta adheesta) {
		String query = "DELETE  FROM ADHEESTA WHERE AHCODIGO=? AND AHCOES=?";
		this.jdbcTemplate.update(query, adheesta.getAhcodigo(), adheesta
				.getEstablec().getEscodigo());
	}

	/**
	 * Finds a List of rows in the Adheesta table.
	 * 
	 * @param adheesta
	 *            Adheesta
	 * @param pagination
	 *            Pagination
	 * @return List
	 */
	@Transactional(readOnly = true)
	public List<Adheesta> findAll(Adheesta adheesta, Pagination pagination) {
		StringBuffer where = new StringBuffer(
				Y38aEstablecAdheConstantes.NUM_3000);
		List<Object> params = new ArrayList<Object>();
		where.append(" WHERE 1=1 AND t1.AHCOSE= t2.SECODIGO(+) 	");

		StringBuffer query = new StringBuffer(
				"SELECT  t1.AHCODIGO AHCODIGO,t1.AHCOES AHCOES,t1.AHCOEX AHCOEX,t1.AHNRDI AHNRDI,t1.AHFECODI AHFECODI,t1.AHFEBA AHFEBA,t1.AHCOTAG AHCOTAG,t1.AHCOT2 AHCOT2,t1.AHCOAV AHCOAV,t1.AHCOSEDE AHCOSEDE,t1.AHFEPUCD AHFEPUCD,t1.AHFEPUBA AHFEPUBA,t1.AHCOCC AHCOCC,t1.AHNIREP AHNIREP,t1.AHNOREP AHNOREP,t1.AHNOAP1R AHNOAP1R,t1.AHNOAP2R AHNOAP2R,t1.AHNOCARE AHNOCARE,t1.AHFERE AHFERE,t1.AHTELIMI AHTELIMI,t1.AHINAMNA AHINAMNA,t1.AHCOJA AHCOJA,t1.AHCOZS AHCOZS,t1.AHCOJAAD AHCOJAAD,t2.SECODIGO SECTORESSECODIGO,t2.SENOMBRE SECTORESSENOMBRE,t2.SENOCO SECTORESSENOCO,t2.SEDESCRI SECTORESSEDESCRI,t2.SECOSE SECTORESSECOSE,t2.SENOCO2 SECTORESSENOCO2,t2.SEINSEL1 SECTORESSEINSEL1,t2.SENOMBREE SECTORESSENOMBREE,t2.SENOMBREI SECTORESSENOMBREI,t2.SENOMBREF SECTORESSENOMBREF,t2.SENOCOE SECTORESSENOCOE,t2.SENOCOI SECTORESSENOCOI,t2.SENOCOF SECTORESSENOCOF,t2.SEDESCRIE SECTORESSEDESCRIE,t2.SEDESCRII SECTORESSEDESCRII,t2.SEDESCRIF SECTORESSEDESCRIF,t2.SENOMBREA SECTORESSENOMBREA,t2.SEDESCRIA SECTORESSEDESCRIA,t2.SENOCOA SECTORESSENOCOA,t2.SECOL0 SECTORESSECOL0,t2.SECODGRUPO SECTORESSECODGRUPO "
						+ "FROM ADHEESTA t1 ,SECTORES t2 ");

		if (adheesta != null && adheesta.getAhcodigo() != null) {
			where.append(" AND t1.AHCODIGO = ?");
			params.add(adheesta.getAhcodigo());
		}
		if (adheesta != null && adheesta.getEstablec().getEscodigo() != null) {
			where.append(" AND t1.ESCODIGO = ?");
			params.add(adheesta.getEstablec().getEscodigo());
		}
		if (adheesta != null && adheesta.getSectores() != null
				&& adheesta.getSectores().getSecodigo() != null) {
			where.append(" AND t2.SECODIGO = ?");
			params.add(adheesta.getSectores().getSecodigo());
		}
		if (adheesta != null
				&& adheesta.getSectores() != null
				&& adheesta.getSectores().getSecagrupBySecol0() != null
				&& adheesta.getSectores().getSecagrupBySecol0().getL0codigo() != null) {
			where.append(" AND t2.SECOL0 = ?");
			params.add(adheesta.getSectores().getSecagrupBySecol0()
					.getL0codigo());
		}
		if (adheesta != null
				&& adheesta.getSectores() != null
				&& adheesta.getSectores().getSecagrupBySecodgrupo() != null
				&& adheesta.getSectores().getSecagrupBySecodgrupo()
						.getL0codigo() != null) {
			where.append(" AND t2.SECODGRUPO = ?");
			params.add(adheesta.getSectores().getSecagrupBySecodgrupo()
					.getL0codigo());
		}
		if (adheesta != null && adheesta.getSectores() != null
				&& adheesta.getSectores().getSenombre() != null) {
			where.append(" AND t2.SENOMBRE = ?");
			params.add(adheesta.getSectores().getSenombre());
		}
		if (adheesta != null && adheesta.getSectores() != null
				&& adheesta.getSectores().getSenoco() != null) {
			where.append(" AND t2.SENOCO = ?");
			params.add(adheesta.getSectores().getSenoco());
		}
		if (adheesta != null && adheesta.getSectores() != null
				&& adheesta.getSectores().getSedescri() != null) {
			where.append(" AND t2.SEDESCRI = ?");
			params.add(adheesta.getSectores().getSedescri());
		}
		if (adheesta != null && adheesta.getSectores() != null
				&& adheesta.getSectores().getSecose() != null) {
			where.append(" AND t2.SECOSE = ?");
			params.add(adheesta.getSectores().getSecose());
		}
		if (adheesta != null && adheesta.getSectores() != null
				&& adheesta.getSectores().getSenoco2() != null) {
			where.append(" AND t2.SENOCO2 = ?");
			params.add(adheesta.getSectores().getSenoco2());
		}
		if (adheesta != null && adheesta.getSectores() != null
				&& adheesta.getSectores().getSeinsel1() != null) {
			where.append(" AND t2.SEINSEL1 = ?");
			params.add(adheesta.getSectores().getSeinsel1());
		}
		if (adheesta != null && adheesta.getSectores() != null
				&& adheesta.getSectores().getSenombree() != null) {
			where.append(" AND t2.SENOMBREE = ?");
			params.add(adheesta.getSectores().getSenombree());
		}
		if (adheesta != null && adheesta.getSectores() != null
				&& adheesta.getSectores().getSenombrei() != null) {
			where.append(" AND t2.SENOMBREI = ?");
			params.add(adheesta.getSectores().getSenombrei());
		}
		if (adheesta != null && adheesta.getSectores() != null
				&& adheesta.getSectores().getSenombref() != null) {
			where.append(" AND t2.SENOMBREF = ?");
			params.add(adheesta.getSectores().getSenombref());
		}
		if (adheesta != null && adheesta.getSectores() != null
				&& adheesta.getSectores().getSenocoe() != null) {
			where.append(" AND t2.SENOCOE = ?");
			params.add(adheesta.getSectores().getSenocoe());
		}
		if (adheesta != null && adheesta.getSectores() != null
				&& adheesta.getSectores().getSenocoi() != null) {
			where.append(" AND t2.SENOCOI = ?");
			params.add(adheesta.getSectores().getSenocoi());
		}
		if (adheesta != null && adheesta.getSectores() != null
				&& adheesta.getSectores().getSenocof() != null) {
			where.append(" AND t2.SENOCOF = ?");
			params.add(adheesta.getSectores().getSenocof());
		}
		if (adheesta != null && adheesta.getSectores() != null
				&& adheesta.getSectores().getSedescrie() != null) {
			where.append(" AND t2.SEDESCRIE = ?");
			params.add(adheesta.getSectores().getSedescrie());
		}
		if (adheesta != null && adheesta.getSectores() != null
				&& adheesta.getSectores().getSedescrii() != null) {
			where.append(" AND t2.SEDESCRII = ?");
			params.add(adheesta.getSectores().getSedescrii());
		}
		if (adheesta != null && adheesta.getSectores() != null
				&& adheesta.getSectores().getSedescrif() != null) {
			where.append(" AND t2.SEDESCRIF = ?");
			params.add(adheesta.getSectores().getSedescrif());
		}
		if (adheesta != null && adheesta.getSectores() != null
				&& adheesta.getSectores().getSenombrea() != null) {
			where.append(" AND t2.SENOMBREA = ?");
			params.add(adheesta.getSectores().getSenombrea());
		}
		if (adheesta != null && adheesta.getSectores() != null
				&& adheesta.getSectores().getSedescria() != null) {
			where.append(" AND t2.SEDESCRIA = ?");
			params.add(adheesta.getSectores().getSedescria());
		}
		if (adheesta != null && adheesta.getSectores() != null
				&& adheesta.getSectores().getSenocoa() != null) {
			where.append(" AND t2.SENOCOA = ?");
			params.add(adheesta.getSectores().getSenocoa());
		}
		if (adheesta != null && adheesta.getAhcoex() != null) {
			where.append(" AND t1.AHCOEX = ?");
			params.add(adheesta.getAhcoex());
		}
		if (adheesta != null && adheesta.getAhnrdi() != null) {
			where.append(" AND t1.AHNRDI = ?");
			params.add(adheesta.getAhnrdi());
		}
		if (adheesta != null && adheesta.getAhfecodi() != null) {
			where.append(" AND t1.AHFECODI = ?");
			params.add(adheesta.getAhfecodi());
		}
		if (adheesta != null && adheesta.getAhfeba() != null) {
			where.append(" AND t1.AHFEBA = ?");
			params.add(adheesta.getAhfeba());
		}
		if (adheesta != null && adheesta.getAhcotag() != null) {
			where.append(" AND t1.AHCOTAG = ?");
			params.add(adheesta.getAhcotag());
		}
		if (adheesta != null && adheesta.getAhcot2() != null) {
			where.append(" AND t1.AHCOT2 = ?");
			params.add(adheesta.getAhcot2());
		}
		if (adheesta != null && adheesta.getAhcoav() != null) {
			where.append(" AND t1.AHCOAV = ?");
			params.add(adheesta.getAhcoav());
		}
		if (adheesta != null && adheesta.getAhcosede() != null) {
			where.append(" AND t1.AHCOSEDE = ?");
			params.add(adheesta.getAhcosede());
		}
		if (adheesta != null && adheesta.getAhfepucd() != null) {
			where.append(" AND t1.AHFEPUCD = ?");
			params.add(adheesta.getAhfepucd());
		}
		if (adheesta != null && adheesta.getAhfepuba() != null) {
			where.append(" AND t1.AHFEPUBA = ?");
			params.add(adheesta.getAhfepuba());
		}
		if (adheesta != null && adheesta.getAhcocc() != null) {
			where.append(" AND t1.AHCOCC = ?");
			params.add(adheesta.getAhcocc());
		}
		if (adheesta != null && adheesta.getAhnirep() != null) {
			where.append(" AND t1.AHNIREP = ?");
			params.add(adheesta.getAhnirep());
		}
		if (adheesta != null && adheesta.getAhnorep() != null) {
			where.append(" AND t1.AHNOREP = ?");
			params.add(adheesta.getAhnorep());
		}
		if (adheesta != null && adheesta.getAhnoap1r() != null) {
			where.append(" AND t1.AHNOAP1R = ?");
			params.add(adheesta.getAhnoap1r());
		}
		if (adheesta != null && adheesta.getAhnoap2r() != null) {
			where.append(" AND t1.AHNOAP2R = ?");
			params.add(adheesta.getAhnoap2r());
		}
		if (adheesta != null && adheesta.getAhnocare() != null) {
			where.append(" AND t1.AHNOCARE = ?");
			params.add(adheesta.getAhnocare());
		}
		if (adheesta != null && adheesta.getAhfere() != null) {
			where.append(" AND t1.AHFERE = ?");
			params.add(adheesta.getAhfere());
		}
		if (adheesta != null && adheesta.getAhtelimi() != null) {
			where.append(" AND t1.AHTELIMI = ?");
			params.add(adheesta.getAhtelimi());
		}
		if (adheesta != null && adheesta.getAhinamna() != null) {
			where.append(" AND t1.AHINAMNA = ?");
			params.add(adheesta.getAhinamna());
		}
		if (adheesta != null && adheesta.getAhcoja() != null) {
			where.append(" AND t1.AHCOJA = ?");
			params.add(adheesta.getAhcoja());
		}
		if (adheesta != null && adheesta.getAhcozs() != null) {
			where.append(" AND t1.AHCOZS = ?");
			params.add(adheesta.getAhcozs());
		}
		if (adheesta != null && adheesta.getAhcojaad() != null) {
			where.append(" AND t1.AHCOJAAD = ?");
			params.add(adheesta.getAhcojaad());
		}
		query.append(where);

		StringBuffer order = new StringBuffer(
				Y38aEstablecAdheConstantes.NUM_3000);
		if (pagination != null) {
			if (pagination.getSort() != null) {
				order.append(" ORDER BY " + pagination.getSort() + " "
						+ pagination.getAscDsc());
				query.append(order);
			}
			query = new StringBuffer(PaginationManager.getQueryLimits(
					pagination, query.toString()));
		}
		return (List<Adheesta>) this.jdbcTemplate.query(query.toString(),
				rwMap, params.toArray());
	}

	/**
	 * Counts rows in the Adheesta table.
	 * 
	 * @param adheesta
	 *            Adheesta
	 * @return Long
	 */
	@Transactional(readOnly = true)
	public Long findAllCount(Adheesta adheesta) {

		StringBuffer where = new StringBuffer(
				Y38aEstablecAdheConstantes.NUM_3000);
		List<Object> params = new ArrayList<Object>();
		where.append(" WHERE 1=1  and t1.AHCOSE= t2.SECODIGO(+) ");

		StringBuffer query = new StringBuffer(
				"SELECT COUNT(1) FROM  ADHEESTA t1   ,  SECTORES t2  ");
		if (adheesta != null && adheesta.getAhcodigo() != null) {
			where.append(" AND t1.AHCODIGO = ?");
			params.add(adheesta.getAhcodigo());
		}
		if (adheesta != null && adheesta.getEstablec().getEscodigo() != null) {
			where.append(" AND t1.ESCODIGO = ?");
			params.add(adheesta.getEstablec().getEscodigo());
		}
		if (adheesta != null && adheesta.getSectores() != null
				&& adheesta.getSectores().getSecodigo() != null) {
			where.append(" AND t2.SECODIGO = ?");
			params.add(adheesta.getSectores().getSecodigo());
		}
		if (adheesta != null
				&& adheesta.getSectores() != null
				&& adheesta.getSectores().getSecagrupBySecol0() != null
				&& adheesta.getSectores().getSecagrupBySecol0().getL0codigo() != null) {
			where.append(" AND t2.SECOL0 = ?");
			params.add(adheesta.getSectores().getSecagrupBySecol0()
					.getL0codigo());
		}
		if (adheesta != null
				&& adheesta.getSectores() != null
				&& adheesta.getSectores().getSecagrupBySecodgrupo() != null
				&& adheesta.getSectores().getSecagrupBySecodgrupo()
						.getL0codigo() != null) {
			where.append(" AND t2.SECODGRUPO = ?");
			params.add(adheesta.getSectores().getSecagrupBySecodgrupo()
					.getL0codigo());
		}
		if (adheesta != null && adheesta.getSectores() != null
				&& adheesta.getSectores().getSenombre() != null) {
			where.append(" AND t2.SENOMBRE = ?");
			params.add(adheesta.getSectores().getSenombre());
		}
		if (adheesta != null && adheesta.getSectores() != null
				&& adheesta.getSectores().getSenoco() != null) {
			where.append(" AND t2.SENOCO = ?");
			params.add(adheesta.getSectores().getSenoco());
		}
		if (adheesta != null && adheesta.getSectores() != null
				&& adheesta.getSectores().getSedescri() != null) {
			where.append(" AND t2.SEDESCRI = ?");
			params.add(adheesta.getSectores().getSedescri());
		}
		if (adheesta != null && adheesta.getSectores() != null
				&& adheesta.getSectores().getSecose() != null) {
			where.append(" AND t2.SECOSE = ?");
			params.add(adheesta.getSectores().getSecose());
		}
		if (adheesta != null && adheesta.getSectores() != null
				&& adheesta.getSectores().getSenoco2() != null) {
			where.append(" AND t2.SENOCO2 = ?");
			params.add(adheesta.getSectores().getSenoco2());
		}
		if (adheesta != null && adheesta.getSectores() != null
				&& adheesta.getSectores().getSeinsel1() != null) {
			where.append(" AND t2.SEINSEL1 = ?");
			params.add(adheesta.getSectores().getSeinsel1());
		}
		if (adheesta != null && adheesta.getSectores() != null
				&& adheesta.getSectores().getSenombree() != null) {
			where.append(" AND t2.SENOMBREE = ?");
			params.add(adheesta.getSectores().getSenombree());
		}
		if (adheesta != null && adheesta.getSectores() != null
				&& adheesta.getSectores().getSenombrei() != null) {
			where.append(" AND t2.SENOMBREI = ?");
			params.add(adheesta.getSectores().getSenombrei());
		}
		if (adheesta != null && adheesta.getSectores() != null
				&& adheesta.getSectores().getSenombref() != null) {
			where.append(" AND t2.SENOMBREF = ?");
			params.add(adheesta.getSectores().getSenombref());
		}
		if (adheesta != null && adheesta.getSectores() != null
				&& adheesta.getSectores().getSenocoe() != null) {
			where.append(" AND t2.SENOCOE = ?");
			params.add(adheesta.getSectores().getSenocoe());
		}
		if (adheesta != null && adheesta.getSectores() != null
				&& adheesta.getSectores().getSenocoi() != null) {
			where.append(" AND t2.SENOCOI = ?");
			params.add(adheesta.getSectores().getSenocoi());
		}
		if (adheesta != null && adheesta.getSectores() != null
				&& adheesta.getSectores().getSenocof() != null) {
			where.append(" AND t2.SENOCOF = ?");
			params.add(adheesta.getSectores().getSenocof());
		}
		if (adheesta != null && adheesta.getSectores() != null
				&& adheesta.getSectores().getSedescrie() != null) {
			where.append(" AND t2.SEDESCRIE = ?");
			params.add(adheesta.getSectores().getSedescrie());
		}
		if (adheesta != null && adheesta.getSectores() != null
				&& adheesta.getSectores().getSedescrii() != null) {
			where.append(" AND t2.SEDESCRII = ?");
			params.add(adheesta.getSectores().getSedescrii());
		}
		if (adheesta != null && adheesta.getSectores() != null
				&& adheesta.getSectores().getSedescrif() != null) {
			where.append(" AND t2.SEDESCRIF = ?");
			params.add(adheesta.getSectores().getSedescrif());
		}
		if (adheesta != null && adheesta.getSectores() != null
				&& adheesta.getSectores().getSenombrea() != null) {
			where.append(" AND t2.SENOMBREA = ?");
			params.add(adheesta.getSectores().getSenombrea());
		}
		if (adheesta != null && adheesta.getSectores() != null
				&& adheesta.getSectores().getSedescria() != null) {
			where.append(" AND t2.SEDESCRIA = ?");
			params.add(adheesta.getSectores().getSedescria());
		}
		if (adheesta != null && adheesta.getSectores() != null
				&& adheesta.getSectores().getSenocoa() != null) {
			where.append(" AND t2.SENOCOA = ?");
			params.add(adheesta.getSectores().getSenocoa());
		}
		if (adheesta != null && adheesta.getAhcoex() != null) {
			where.append(" AND t1.AHCOEX = ?");
			params.add(adheesta.getAhcoex());
		}
		if (adheesta != null && adheesta.getAhnrdi() != null) {
			where.append(" AND t1.AHNRDI = ?");
			params.add(adheesta.getAhnrdi());
		}
		if (adheesta != null && adheesta.getAhfecodi() != null) {
			where.append(" AND t1.AHFECODI = ?");
			params.add(adheesta.getAhfecodi());
		}
		if (adheesta != null && adheesta.getAhfeba() != null) {
			where.append(" AND t1.AHFEBA = ?");
			params.add(adheesta.getAhfeba());
		}
		if (adheesta != null && adheesta.getAhcotag() != null) {
			where.append(" AND t1.AHCOTAG = ?");
			params.add(adheesta.getAhcotag());
		}
		if (adheesta != null && adheesta.getAhcot2() != null) {
			where.append(" AND t1.AHCOT2 = ?");
			params.add(adheesta.getAhcot2());
		}
		if (adheesta != null && adheesta.getAhcoav() != null) {
			where.append(" AND t1.AHCOAV = ?");
			params.add(adheesta.getAhcoav());
		}
		if (adheesta != null && adheesta.getAhcosede() != null) {
			where.append(" AND t1.AHCOSEDE = ?");
			params.add(adheesta.getAhcosede());
		}
		if (adheesta != null && adheesta.getAhfepucd() != null) {
			where.append(" AND t1.AHFEPUCD = ?");
			params.add(adheesta.getAhfepucd());
		}
		if (adheesta != null && adheesta.getAhfepuba() != null) {
			where.append(" AND t1.AHFEPUBA = ?");
			params.add(adheesta.getAhfepuba());
		}
		if (adheesta != null && adheesta.getAhcocc() != null) {
			where.append(" AND t1.AHCOCC = ?");
			params.add(adheesta.getAhcocc());
		}
		if (adheesta != null && adheesta.getAhnirep() != null) {
			where.append(" AND t1.AHNIREP = ?");
			params.add(adheesta.getAhnirep());
		}
		if (adheesta != null && adheesta.getAhnorep() != null) {
			where.append(" AND t1.AHNOREP = ?");
			params.add(adheesta.getAhnorep());
		}
		if (adheesta != null && adheesta.getAhnoap1r() != null) {
			where.append(" AND t1.AHNOAP1R = ?");
			params.add(adheesta.getAhnoap1r());
		}
		if (adheesta != null && adheesta.getAhnoap2r() != null) {
			where.append(" AND t1.AHNOAP2R = ?");
			params.add(adheesta.getAhnoap2r());
		}
		if (adheesta != null && adheesta.getAhnocare() != null) {
			where.append(" AND t1.AHNOCARE = ?");
			params.add(adheesta.getAhnocare());
		}
		if (adheesta != null && adheesta.getAhfere() != null) {
			where.append(" AND t1.AHFERE = ?");
			params.add(adheesta.getAhfere());
		}
		if (adheesta != null && adheesta.getAhtelimi() != null) {
			where.append(" AND t1.AHTELIMI = ?");
			params.add(adheesta.getAhtelimi());
		}
		if (adheesta != null && adheesta.getAhinamna() != null) {
			where.append(" AND t1.AHINAMNA = ?");
			params.add(adheesta.getAhinamna());
		}
		if (adheesta != null && adheesta.getAhcoja() != null) {
			where.append(" AND t1.AHCOJA = ?");
			params.add(adheesta.getAhcoja());
		}
		if (adheesta != null && adheesta.getAhcozs() != null) {
			where.append(" AND t1.AHCOZS = ?");
			params.add(adheesta.getAhcozs());
		}
		if (adheesta != null && adheesta.getAhcojaad() != null) {
			where.append(" AND t1.AHCOJAAD = ?");
			params.add(adheesta.getAhcojaad());
		}
		query.append(where);
		return this.jdbcTemplate.queryForLong(query.toString(),
				params.toArray());
	}

	/**
	 * Finds rows in the Adheesta table using like.
	 * 
	 * @param adheesta
	 *            Adheesta
	 * @param pagination
	 *            Pagination
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	@Transactional(readOnly = true)
	public List<Adheesta> findAllLike(Adheesta adheesta, Pagination pagination,
			Boolean startsWith) {
		StringBuffer where = new StringBuffer(
				Y38aEstablecAdheConstantes.NUM_3000);
		List<Object> params = new ArrayList<Object>();
		where.append(" WHERE 1=1 AND t1.AHCOSE= t2.SECODIGO(+) 	");

		StringBuffer query = new StringBuffer(
				"SELECT  t1.AHCODIGO AHCODIGO,t1.AHCOES AHCOES,t1.AHCOEX AHCOEX,t1.AHNRDI AHNRDI,t1.AHFECODI AHFECODI,t1.AHFEBA AHFEBA,t1.AHCOTAG AHCOTAG,t1.AHCOT2 AHCOT2,t1.AHCOAV AHCOAV,t1.AHCOSEDE AHCOSEDE,t1.AHFEPUCD AHFEPUCD,t1.AHFEPUBA AHFEPUBA,t1.AHCOCC AHCOCC,t1.AHNIREP AHNIREP,t1.AHNOREP AHNOREP,t1.AHNOAP1R AHNOAP1R,t1.AHNOAP2R AHNOAP2R,t1.AHNOCARE AHNOCARE,t1.AHFERE AHFERE,t1.AHTELIMI AHTELIMI,t1.AHINAMNA AHINAMNA,t1.AHCOJA AHCOJA,t1.AHCOZS AHCOZS,t1.AHCOJAAD AHCOJAAD,t2.SECODIGO SECTORESSECODIGO,t2.SENOMBRE SECTORESSENOMBRE,t2.SENOCO SECTORESSENOCO,t2.SEDESCRI SECTORESSEDESCRI,t2.SECOSE SECTORESSECOSE,t2.SENOCO2 SECTORESSENOCO2,t2.SEINSEL1 SECTORESSEINSEL1,t2.SENOMBREE SECTORESSENOMBREE,t2.SENOMBREI SECTORESSENOMBREI,t2.SENOMBREF SECTORESSENOMBREF,t2.SENOCOE SECTORESSENOCOE,t2.SENOCOI SECTORESSENOCOI,t2.SENOCOF SECTORESSENOCOF,t2.SEDESCRIE SECTORESSEDESCRIE,t2.SEDESCRII SECTORESSEDESCRII,t2.SEDESCRIF SECTORESSEDESCRIF,t2.SENOMBREA SECTORESSENOMBREA,t2.SEDESCRIA SECTORESSEDESCRIA,t2.SENOCOA SECTORESSENOCOA,t2.SECOL0 SECTORESSECOL0,t2.SECODGRUPO SECTORESSECODGRUPO "
						+ "FROM ADHEESTA t1 ,SECTORES t2 ");

		if (adheesta != null && adheesta.getAhcodigo() != null) {
			where.append(" AND UPPER(t1.AHCODIGO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(adheesta.getAhcodigo().toUpperCase() + "%");
			} else {
				params.add("%" + adheesta.getAhcodigo().toUpperCase() + "%");
			}
			where.append(" AND t1.AHCODIGO IS NOT NULL");
		}
		if (adheesta != null && adheesta.getEstablec().getEscodigo() != null) {
			where.append(" AND UPPER(t1.ESCODIGO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(adheesta.getEstablec().getEscodigo().toUpperCase()
						+ "%");
			} else {
				params.add("%"
						+ adheesta.getEstablec().getEscodigo().toUpperCase()
						+ "%");
			}
			where.append(" AND t1.ESCODIGO IS NOT NULL");
		}
		if (adheesta != null && adheesta.getSectores() != null
				&& adheesta.getSectores().getSecodigo() != null) {
			where.append(" AND t2.SECODIGO like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(adheesta.getSectores().getSecodigo() + "%");
			} else {
				params.add("%" + adheesta.getSectores().getSecodigo() + "%");
			}
			where.append(" AND t2.SECODIGO IS NOT NULL");
		}
		if (adheesta != null
				&& adheesta.getSectores() != null
				&& adheesta.getSectores().getSecagrupBySecol0() != null
				&& adheesta.getSectores().getSecagrupBySecol0().getL0codigo() != null) {
			where.append(" AND UPPER(t2.SECOL0) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(adheesta.getSectores().getSecagrupBySecol0()
						.getL0codigo().toUpperCase()
						+ "%");
			} else {
				params.add("%"
						+ adheesta.getSectores().getSecagrupBySecol0()
								.getL0codigo().toUpperCase() + "%");
			}
			where.append(" AND t2.SECOL0 IS NOT NULL");
		}
		if (adheesta != null
				&& adheesta.getSectores() != null
				&& adheesta.getSectores().getSecagrupBySecodgrupo() != null
				&& adheesta.getSectores().getSecagrupBySecodgrupo()
						.getL0codigo() != null) {
			where.append(" AND UPPER(t2.SECODGRUPO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(adheesta.getSectores().getSecagrupBySecodgrupo()
						.getL0codigo().toUpperCase()
						+ "%");
			} else {
				params.add("%"
						+ adheesta.getSectores().getSecagrupBySecodgrupo()
								.getL0codigo().toUpperCase() + "%");
			}
			where.append(" AND t2.SECODGRUPO IS NOT NULL");
		}
		if (adheesta != null && adheesta.getSectores() != null
				&& adheesta.getSectores().getSenombre() != null) {
			where.append(" AND UPPER(t2.SENOMBRE) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(adheesta.getSectores().getSenombre().toUpperCase()
						+ "%");
			} else {
				params.add("%"
						+ adheesta.getSectores().getSenombre().toUpperCase()
						+ "%");
			}
			where.append(" AND t2.SENOMBRE IS NOT NULL");
		}
		if (adheesta != null && adheesta.getSectores() != null
				&& adheesta.getSectores().getSenoco() != null) {
			where.append(" AND UPPER(t2.SENOCO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(adheesta.getSectores().getSenoco().toUpperCase()
						+ "%");
			} else {
				params.add("%"
						+ adheesta.getSectores().getSenoco().toUpperCase()
						+ "%");
			}
			where.append(" AND t2.SENOCO IS NOT NULL");
		}
		if (adheesta != null && adheesta.getSectores() != null
				&& adheesta.getSectores().getSedescri() != null) {
			where.append(" AND UPPER(t2.SEDESCRI) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(adheesta.getSectores().getSedescri().toUpperCase()
						+ "%");
			} else {
				params.add("%"
						+ adheesta.getSectores().getSedescri().toUpperCase()
						+ "%");
			}
			where.append(" AND t2.SEDESCRI IS NOT NULL");
		}
		if (adheesta != null && adheesta.getSectores() != null
				&& adheesta.getSectores().getSecose() != null) {
			where.append(" AND UPPER(t2.SECOSE) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(adheesta.getSectores().getSecose().toUpperCase()
						+ "%");
			} else {
				params.add("%"
						+ adheesta.getSectores().getSecose().toUpperCase()
						+ "%");
			}
			where.append(" AND t2.SECOSE IS NOT NULL");
		}
		if (adheesta != null && adheesta.getSectores() != null
				&& adheesta.getSectores().getSenoco2() != null) {
			where.append(" AND UPPER(t2.SENOCO2) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(adheesta.getSectores().getSenoco2().toUpperCase()
						+ "%");
			} else {
				params.add("%"
						+ adheesta.getSectores().getSenoco2().toUpperCase()
						+ "%");
			}
			where.append(" AND t2.SENOCO2 IS NOT NULL");
		}
		if (adheesta != null && adheesta.getSectores() != null
				&& adheesta.getSectores().getSeinsel1() != null) {
			where.append(" AND UPPER(t2.SEINSEL1) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(adheesta.getSectores().getSeinsel1().toUpperCase()
						+ "%");
			} else {
				params.add("%"
						+ adheesta.getSectores().getSeinsel1().toUpperCase()
						+ "%");
			}
			where.append(" AND t2.SEINSEL1 IS NOT NULL");
		}
		if (adheesta != null && adheesta.getSectores() != null
				&& adheesta.getSectores().getSenombree() != null) {
			where.append(" AND UPPER(t2.SENOMBREE) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(adheesta.getSectores().getSenombree().toUpperCase()
						+ "%");
			} else {
				params.add("%"
						+ adheesta.getSectores().getSenombree().toUpperCase()
						+ "%");
			}
			where.append(" AND t2.SENOMBREE IS NOT NULL");
		}
		if (adheesta != null && adheesta.getSectores() != null
				&& adheesta.getSectores().getSenombrei() != null) {
			where.append(" AND UPPER(t2.SENOMBREI) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(adheesta.getSectores().getSenombrei().toUpperCase()
						+ "%");
			} else {
				params.add("%"
						+ adheesta.getSectores().getSenombrei().toUpperCase()
						+ "%");
			}
			where.append(" AND t2.SENOMBREI IS NOT NULL");
		}
		if (adheesta != null && adheesta.getSectores() != null
				&& adheesta.getSectores().getSenombref() != null) {
			where.append(" AND UPPER(t2.SENOMBREF) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(adheesta.getSectores().getSenombref().toUpperCase()
						+ "%");
			} else {
				params.add("%"
						+ adheesta.getSectores().getSenombref().toUpperCase()
						+ "%");
			}
			where.append(" AND t2.SENOMBREF IS NOT NULL");
		}
		if (adheesta != null && adheesta.getSectores() != null
				&& adheesta.getSectores().getSenocoe() != null) {
			where.append(" AND UPPER(t2.SENOCOE) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(adheesta.getSectores().getSenocoe().toUpperCase()
						+ "%");
			} else {
				params.add("%"
						+ adheesta.getSectores().getSenocoe().toUpperCase()
						+ "%");
			}
			where.append(" AND t2.SENOCOE IS NOT NULL");
		}
		if (adheesta != null && adheesta.getSectores() != null
				&& adheesta.getSectores().getSenocoi() != null) {
			where.append(" AND UPPER(t2.SENOCOI) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(adheesta.getSectores().getSenocoi().toUpperCase()
						+ "%");
			} else {
				params.add("%"
						+ adheesta.getSectores().getSenocoi().toUpperCase()
						+ "%");
			}
			where.append(" AND t2.SENOCOI IS NOT NULL");
		}
		if (adheesta != null && adheesta.getSectores() != null
				&& adheesta.getSectores().getSenocof() != null) {
			where.append(" AND UPPER(t2.SENOCOF) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(adheesta.getSectores().getSenocof().toUpperCase()
						+ "%");
			} else {
				params.add("%"
						+ adheesta.getSectores().getSenocof().toUpperCase()
						+ "%");
			}
			where.append(" AND t2.SENOCOF IS NOT NULL");
		}
		if (adheesta != null && adheesta.getSectores() != null
				&& adheesta.getSectores().getSedescrie() != null) {
			where.append(" AND UPPER(t2.SEDESCRIE) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(adheesta.getSectores().getSedescrie().toUpperCase()
						+ "%");
			} else {
				params.add("%"
						+ adheesta.getSectores().getSedescrie().toUpperCase()
						+ "%");
			}
			where.append(" AND t2.SEDESCRIE IS NOT NULL");
		}
		if (adheesta != null && adheesta.getSectores() != null
				&& adheesta.getSectores().getSedescrii() != null) {
			where.append(" AND UPPER(t2.SEDESCRII) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(adheesta.getSectores().getSedescrii().toUpperCase()
						+ "%");
			} else {
				params.add("%"
						+ adheesta.getSectores().getSedescrii().toUpperCase()
						+ "%");
			}
			where.append(" AND t2.SEDESCRII IS NOT NULL");
		}
		if (adheesta != null && adheesta.getSectores() != null
				&& adheesta.getSectores().getSedescrif() != null) {
			where.append(" AND UPPER(t2.SEDESCRIF) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(adheesta.getSectores().getSedescrif().toUpperCase()
						+ "%");
			} else {
				params.add("%"
						+ adheesta.getSectores().getSedescrif().toUpperCase()
						+ "%");
			}
			where.append(" AND t2.SEDESCRIF IS NOT NULL");
		}
		if (adheesta != null && adheesta.getSectores() != null
				&& adheesta.getSectores().getSenombrea() != null) {
			where.append(" AND UPPER(t2.SENOMBREA) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(adheesta.getSectores().getSenombrea().toUpperCase()
						+ "%");
			} else {
				params.add("%"
						+ adheesta.getSectores().getSenombrea().toUpperCase()
						+ "%");
			}
			where.append(" AND t2.SENOMBREA IS NOT NULL");
		}
		if (adheesta != null && adheesta.getSectores() != null
				&& adheesta.getSectores().getSedescria() != null) {
			where.append(" AND UPPER(t2.SEDESCRIA) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(adheesta.getSectores().getSedescria().toUpperCase()
						+ "%");
			} else {
				params.add("%"
						+ adheesta.getSectores().getSedescria().toUpperCase()
						+ "%");
			}
			where.append(" AND t2.SEDESCRIA IS NOT NULL");
		}
		if (adheesta != null && adheesta.getSectores() != null
				&& adheesta.getSectores().getSenocoa() != null) {
			where.append(" AND UPPER(t2.SENOCOA) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(adheesta.getSectores().getSenocoa().toUpperCase()
						+ "%");
			} else {
				params.add("%"
						+ adheesta.getSectores().getSenocoa().toUpperCase()
						+ "%");
			}
			where.append(" AND t2.SENOCOA IS NOT NULL");
		}
		if (adheesta != null && adheesta.getAhcoex() != null) {
			where.append(" AND t1.AHCOEX like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(adheesta.getAhcoex() + "%");
			} else {
				params.add("%" + adheesta.getAhcoex() + "%");
			}
			where.append(" AND t1.AHCOEX IS NOT NULL");
		}
		if (adheesta != null && adheesta.getAhnrdi() != null) {
			where.append(" AND t1.AHNRDI like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(adheesta.getAhnrdi() + "%");
			} else {
				params.add("%" + adheesta.getAhnrdi() + "%");
			}
			where.append(" AND t1.AHNRDI IS NOT NULL");
		}
		if (adheesta != null && adheesta.getAhfecodi() != null) {
			where.append(" AND t1.AHFECODI like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(adheesta.getAhfecodi() + "%");
			} else {
				params.add("%" + adheesta.getAhfecodi() + "%");
			}
			where.append(" AND t1.AHFECODI IS NOT NULL");
		}
		if (adheesta != null && adheesta.getAhfeba() != null) {
			where.append(" AND t1.AHFEBA like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(adheesta.getAhfeba() + "%");
			} else {
				params.add("%" + adheesta.getAhfeba() + "%");
			}
			where.append(" AND t1.AHFEBA IS NOT NULL");
		}
		if (adheesta != null && adheesta.getAhcotag() != null) {
			where.append(" AND UPPER(t1.AHCOTAG) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(adheesta.getAhcotag().toUpperCase() + "%");
			} else {
				params.add("%" + adheesta.getAhcotag().toUpperCase() + "%");
			}
			where.append(" AND t1.AHCOTAG IS NOT NULL");
		}
		if (adheesta != null && adheesta.getAhcot2() != null) {
			where.append(" AND UPPER(t1.AHCOT2) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(adheesta.getAhcot2().toUpperCase() + "%");
			} else {
				params.add("%" + adheesta.getAhcot2().toUpperCase() + "%");
			}
			where.append(" AND t1.AHCOT2 IS NOT NULL");
		}
		if (adheesta != null && adheesta.getAhcoav() != null) {
			where.append(" AND UPPER(t1.AHCOAV) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(adheesta.getAhcoav().toUpperCase() + "%");
			} else {
				params.add("%" + adheesta.getAhcoav().toUpperCase() + "%");
			}
			where.append(" AND t1.AHCOAV IS NOT NULL");
		}
		if (adheesta != null && adheesta.getAhcosede() != null) {
			where.append(" AND UPPER(t1.AHCOSEDE) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(adheesta.getAhcosede().toUpperCase() + "%");
			} else {
				params.add("%" + adheesta.getAhcosede().toUpperCase() + "%");
			}
			where.append(" AND t1.AHCOSEDE IS NOT NULL");
		}
		if (adheesta != null && adheesta.getAhfepucd() != null) {
			where.append(" AND t1.AHFEPUCD like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(adheesta.getAhfepucd() + "%");
			} else {
				params.add("%" + adheesta.getAhfepucd() + "%");
			}
			where.append(" AND t1.AHFEPUCD IS NOT NULL");
		}
		if (adheesta != null && adheesta.getAhfepuba() != null) {
			where.append(" AND t1.AHFEPUBA like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(adheesta.getAhfepuba() + "%");
			} else {
				params.add("%" + adheesta.getAhfepuba() + "%");
			}
			where.append(" AND t1.AHFEPUBA IS NOT NULL");
		}
		if (adheesta != null && adheesta.getAhcocc() != null) {
			where.append(" AND UPPER(t1.AHCOCC) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(adheesta.getAhcocc().toUpperCase() + "%");
			} else {
				params.add("%" + adheesta.getAhcocc().toUpperCase() + "%");
			}
			where.append(" AND t1.AHCOCC IS NOT NULL");
		}
		if (adheesta != null && adheesta.getAhnirep() != null) {
			where.append(" AND UPPER(t1.AHNIREP) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(adheesta.getAhnirep().toUpperCase() + "%");
			} else {
				params.add("%" + adheesta.getAhnirep().toUpperCase() + "%");
			}
			where.append(" AND t1.AHNIREP IS NOT NULL");
		}
		if (adheesta != null && adheesta.getAhnorep() != null) {
			where.append(" AND UPPER(t1.AHNOREP) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(adheesta.getAhnorep().toUpperCase() + "%");
			} else {
				params.add("%" + adheesta.getAhnorep().toUpperCase() + "%");
			}
			where.append(" AND t1.AHNOREP IS NOT NULL");
		}
		if (adheesta != null && adheesta.getAhnoap1r() != null) {
			where.append(" AND UPPER(t1.AHNOAP1R) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(adheesta.getAhnoap1r().toUpperCase() + "%");
			} else {
				params.add("%" + adheesta.getAhnoap1r().toUpperCase() + "%");
			}
			where.append(" AND t1.AHNOAP1R IS NOT NULL");
		}
		if (adheesta != null && adheesta.getAhnoap2r() != null) {
			where.append(" AND UPPER(t1.AHNOAP2R) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(adheesta.getAhnoap2r().toUpperCase() + "%");
			} else {
				params.add("%" + adheesta.getAhnoap2r().toUpperCase() + "%");
			}
			where.append(" AND t1.AHNOAP2R IS NOT NULL");
		}
		if (adheesta != null && adheesta.getAhnocare() != null) {
			where.append(" AND UPPER(t1.AHNOCARE) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(adheesta.getAhnocare().toUpperCase() + "%");
			} else {
				params.add("%" + adheesta.getAhnocare().toUpperCase() + "%");
			}
			where.append(" AND t1.AHNOCARE IS NOT NULL");
		}
		if (adheesta != null && adheesta.getAhfere() != null) {
			where.append(" AND t1.AHFERE like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(adheesta.getAhfere() + "%");
			} else {
				params.add("%" + adheesta.getAhfere() + "%");
			}
			where.append(" AND t1.AHFERE IS NOT NULL");
		}
		if (adheesta != null && adheesta.getAhtelimi() != null) {
			where.append(" AND UPPER(t1.AHTELIMI) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(adheesta.getAhtelimi().toUpperCase() + "%");
			} else {
				params.add("%" + adheesta.getAhtelimi().toUpperCase() + "%");
			}
			where.append(" AND t1.AHTELIMI IS NOT NULL");
		}
		if (adheesta != null && adheesta.getAhinamna() != null) {
			where.append(" AND UPPER(t1.AHINAMNA) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(adheesta.getAhinamna().toUpperCase() + "%");
			} else {
				params.add("%" + adheesta.getAhinamna().toUpperCase() + "%");
			}
			where.append(" AND t1.AHINAMNA IS NOT NULL");
		}
		if (adheesta != null && adheesta.getAhcoja() != null) {
			where.append(" AND UPPER(t1.AHCOJA) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(adheesta.getAhcoja().toUpperCase() + "%");
			} else {
				params.add("%" + adheesta.getAhcoja().toUpperCase() + "%");
			}
			where.append(" AND t1.AHCOJA IS NOT NULL");
		}
		if (adheesta != null && adheesta.getAhcozs() != null) {
			where.append(" AND UPPER(t1.AHCOZS) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(adheesta.getAhcozs().toUpperCase() + "%");
			} else {
				params.add("%" + adheesta.getAhcozs().toUpperCase() + "%");
			}
			where.append(" AND t1.AHCOZS IS NOT NULL");
		}
		if (adheesta != null && adheesta.getAhcojaad() != null) {
			where.append(" AND UPPER(t1.AHCOJAAD) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(adheesta.getAhcojaad().toUpperCase() + "%");
			} else {
				params.add("%" + adheesta.getAhcojaad().toUpperCase() + "%");
			}
			where.append(" AND t1.AHCOJAAD IS NOT NULL");
		}
		query.append(where);

		StringBuffer order = new StringBuffer(
				Y38aEstablecAdheConstantes.NUM_3000);
		if (pagination != null) {
			if (pagination.getSort() != null) {
				order.append(" ORDER BY " + pagination.getSort() + " "
						+ pagination.getAscDsc());
				query.append(order);
			}
			query = new StringBuffer(PaginationManager.getQueryLimits(
					pagination, query.toString()));
		}
		return (List<Adheesta>) this.jdbcTemplate.query(query.toString(),
				rwMap, params.toArray());
	}
}
