package com.ejie.y38a.dao;

import com.ejie.x38.dto.Pagination;
import java.util.List;

//import org.springframework.transaction.annotation.Transactional;

import com.ejie.y38a.model.Establec;

/**
 * * EstablecDao  
 * 
 *  
 */

public interface EstablecDao {

	/**
	 * Inserts a single row in the Establec table.
	 * 
	 * @param establec
	 *            Establec
	 * @return Establec
	 */
	Establec add(Establec establec);

	/**
	 * Updates a single row in the Establec table.
	 * 
	 * @param establec
	 *            Establec
	 * @return Establec
	 */
	Establec update(Establec establec);

	/**
	 * Finds a single row in the Establec table.
	 * 
	 * @param establec
	 *            Establec
	 * @return Establec
	 */
	Establec find(Establec establec);

	/**
	 * Finds a single row in the Establec table.
	 * 
	 * @param establec
	 *            Establec
	 * @return Establec
	 */
	Establec findEstablecimiento(Establec establec);

	/**
	 * Deletes a single row in the Establec table.
	 * 
	 * @param establec
	 *            Establec
	 * @return
	 */
	void remove(Establec establec);

	/**
	 * Finds a List of rows in the Establec table.
	 * 
	 * @param establec
	 *            Establec
	 * @param pagination
	 *            Pagination
	 * @return List
	 */
	List<Establec> findAll(Establec establec, Pagination pagination);

	/**
	 * Counts rows in the Establec table.
	 * 
	 * @param establec
	 *            Establec
	 * @return List
	 */
	Long findAllCount(Establec establec);

	/**
	 * Finds rows in the Establec table using like.
	 * 
	 * @param establec
	 *            Establec
	 * @param pagination
	 *            Pagination
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<Establec> findAllLike(Establec establec, Pagination pagination,
			Boolean startsWith);

	/**
	 * Finds rows in the Establec table using like.
	 * 
	 * @param establec
	 *            Establec
	 * @param pagination
	 *            Pagination
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<Establec> findAllLikeEstablec(Establec establec,
			Pagination pagination, Boolean startsWith);

	/**
	 * Finds rows in the Establec table using like.
	 * 
	 * @param establec
	 *            Establec
	 * @param pagination
	 *            Pagination
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<Establec> findAllLikeEstablecDistintivo(Establec establec,
			Pagination pagination, Boolean startsWith);

	/**
	 * Counts rows in the Establec table.
	 * 
	 * @param establec
	 *            Establec
	 * @return List
	 */
	Long findAllCountLikeEstablec(Establec establec);

	/**
	 * Counts rows in the Establec table.
	 * 
	 * @param establec
	 *            Establec
	 * @return List
	 */
	Long findAllCountLikeEstablecDistintivo(Establec establec);

	/**
	 * Finds a single row in the Establec table.
	 * 
	 * @param establec
	 *            Establec
	 * @param establecFiltro
	 *            Establec
	 * @return Establec
	 */
	public Establec findLimitaciones(Establec establec, Establec establecFiltro);
}
