package com.ejie.y38a.dao;

import com.ejie.x38.dto.Pagination;
import java.util.List;

import com.ejie.y38a.model.Estasect;

/**
 *  * EstasectDao  
 *  
 */

public interface EstasectDao {
    
    /**
     * Inserts a single row in the Estasect table.
     *
     * @param estasect Estasect
     * @return Estasect
     */
    Estasect add(Estasect estasect);

    /**
     * Updates a single row in the Estasect table.
     *
     * @param estasect Estasect
     * @return Estasect
     */
    Estasect update(Estasect estasect);

    /**
     * Finds a single row in the Estasect table.
     *
     * @param estasect Estasect
     * @return Estasect
     */
    Estasect find(Estasect estasect);

    /**
     * Deletes a single row in the Estasect table.
     *
     * @param estasect Estasect
     * @return 
     */
    void remove(Estasect estasect);

    /**
     * Finds a List of rows in the Estasect table.
     *
     * @param estasect Estasect
     * @param pagination Pagination
     * @return List
     */
    List<Estasect> findAll(Estasect estasect, Pagination pagination);

    /**
     * Counts rows in the Estasect table.
     *
     * @param estasect Estasect
     * @return List
     */
    Long findAllCount(Estasect estasect);
	
	/**
     * Finds rows in the Estasect table using like.
     *
     * @param estasect Estasect
     * @param pagination Pagination
     * @param startsWith Boolean
     * @return List
     */
	List<Estasect> findAllLike(Estasect estasect, Pagination pagination, Boolean startsWith);
}

