package com.ejie.y38a.dao;

import com.ejie.x38.dto.Pagination;
import java.util.List;

import com.ejie.y38a.model.Sectores;

/**
 *  * SectoresDao  
 *  
 */

public interface SectoresDao {
    
    /**
     * Inserts a single row in the Sectores table.
     *
     * @param sectores Sectores
     * @return Sectores
     */
    Sectores add(Sectores sectores);

    /**
     * Updates a single row in the Sectores table.
     *
     * @param sectores Sectores
     * @return Sectores
     */
    Sectores update(Sectores sectores);

    /**
     * Finds a single row in the Sectores table.
     *
     * @param sectores Sectores
     * @return Sectores
     */
    Sectores find(Sectores sectores);

    /**
     * Deletes a single row in the Sectores table.
     *
     * @param sectores Sectores
     * @return 
     */
    void remove(Sectores sectores);

    /**
     * Finds a List of rows in the Sectores table.
     *
     * @param sectores Sectores
     * @param pagination Pagination
     * @return List
     */
    List<Sectores> findAll(Sectores sectores, Pagination pagination);

    /**
     * Counts rows in the Sectores table.
     *
     * @param sectores Sectores
     * @return List
     */
    Long findAllCount(Sectores sectores);
	
	/**
     * Finds rows in the Sectores table using like.
     *
     * @param sectores Sectores
     * @param pagination Pagination
     * @param startsWith Boolean
     * @return List
     */
	List<Sectores> findAllLike(Sectores sectores, Pagination pagination, Boolean startsWith);
}

