package com.ejie.y38a.service;

import com.ejie.x38.dto.Pagination;
import java.util.ArrayList;
import java.util.List;

import com.ejie.y38a.model.Establec;

/**
 * * EstablecService  
 * 
 *  
 */

public interface EstablecService {

	/**
	 * Inserts a single row in the Establec table.
	 * 
	 * @param establec
	 *            Establec
	 * @return Establec
	 */
	Establec add(Establec establec);

	/**
	 * Updates a single row in the Establec table.
	 * 
	 * @param establec
	 *            Establec
	 * @return Establec
	 */
	Establec update(Establec establec);

	/**
	 * Finds a single row in the Establec table.
	 * 
	 * @param establec
	 *            Establec
	 * @return Establec
	 */
	Establec find(Establec establec);

	/**
	 * Finds a single row in the Establec table.
	 * 
	 * @param establec
	 *            Establec
	 * @return Establec
	 */
	Establec findEstablecimiento(Establec establec);

	/**
	 * Finds a List of rows in the Establec table.
	 * 
	 * @param establec
	 *            Establec
	 * @param pagination
	 *            Pagination
	 * @return List
	 */
	List<Establec> findAll(Establec establec, Pagination pagination);

	/**
	 * Counts rows in the Establec table.
	 * 
	 * @param establec
	 *            Establec
	 * @return Long
	 */
	Long findAllCount(Establec establec);

	/**
	 * Finds rows in the Establec table using like.
	 * 
	 * @param establec
	 *            Establec
	 * @param pagination
	 *            Pagination
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<Establec> findAllLike(Establec establec, Pagination pagination,
			Boolean startsWith);

	/**
	 * Deletes a single row in the Establec table.
	 * 
	 * @param establec
	 *            Establec
	 * @return
	 */
	void remove(Establec establec);

	/**
	 * Deletes multiple rows in the Establec table.
	 * 
	 * @param establecList
	 *            ArrayList
	 * @return
	 */
	void removeMultiple(ArrayList<Establec> establecList);

	/**
	 * Deletes multiple rows in the Establec table.
	 * 
	 * @param esnif
	 *            String
	 * 
	 * @return Establec
	 */
	Establec find(String esnif);

	/**
	 * Finds rows in the Establec table using like.
	 * 
	 * @param establec
	 *            Establec
	 * @param pagination
	 *            Pagination
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<Establec> findAllLikeEstablec(Establec establec,
			Pagination pagination, Boolean startsWith);

	/**
	 * Finds rows in the Establec table using like.
	 * 
	 * @param establec
	 *            Establec
	 * @param pagination
	 *            Pagination
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<Establec> findAllLikeEstablecDistintivo(Establec establec,
			Pagination pagination, Boolean startsWith);

	/**
	 * Counts rows in the Establec table.
	 * 
	 * @param establec
	 *            Establec
	 * @return Long
	 */
	Long findAllCountLikeEstablec(Establec establec);

	/**
	 * Counts rows in the Establec table.
	 * 
	 * @param establec
	 *            Establec
	 * @return Long
	 */
	Long findAllCountLikeEstablecDistintivo(Establec establec);

	/**
	 * Envia por mail la solicitud.
	 * 
	 * @param establecDef
	 *            Establec
	 * @return
	 */
	void emailSolicitudDistintivo(Establec establecDef);

}
