package com.ejie.y38a.service;


import com.ejie.x38.dto.Pagination;
import java.util.ArrayList;
import java.util.List;

import com.ejie.y38a.model.Paisesto;

/**
 *  * PaisestoService  
 *  
 */

public interface PaisestoService {

	/**
	 * Inserts a single row in the Paisesto table.
	 *
	 * @param paisesto Paisesto
	 * @return Paisesto
	 */
    Paisesto add(Paisesto paisesto);

	/**
	 * Updates a single row in the Paisesto table.
	 *
	 * @param paisesto Paisesto
	 * @return Paisesto
	 */
	Paisesto update(Paisesto paisesto);

	/**
	 * Finds a single row in the Paisesto table.
	 *
	 * @param paisesto Paisesto
	 * @return Paisesto
	 */
	Paisesto find(Paisesto paisesto);

	/**
	 * Finds a List of rows in the Paisesto table.
	 *
	 * @param paisesto Paisesto
	 * @param pagination Pagination
	 * @return List
	 */
	List<Paisesto> findAll(Paisesto paisesto, Pagination pagination);

	/**
	 * Counts rows in the Paisesto table.
	 *
	 * @param paisesto Paisesto
	 * @return Long
	 */
	Long findAllCount(Paisesto paisesto);
	
	/**
	 * Finds rows in the Paisesto table using like.
	 *
	 * @param paisesto Paisesto
	 * @param pagination Pagination
     * @param startsWith Boolean	 
	 * @return List
	 */
	List<Paisesto> findAllLike(Paisesto paisesto, Pagination pagination, Boolean startsWith) ;
  
	/**
	 * Deletes a single row in the Paisesto table.
	 *
	 * @param paisesto Paisesto
	 * @return 
	 */
	void remove(Paisesto paisesto);
	
	/**
	 * Deletes multiple rows in the Paisesto table.
	 *
	 * @param paisestoList  ArrayList
	 * @return 
	 */	
	void removeMultiple(ArrayList<Paisesto> paisestoList);
    
}


