package com.ejie.y38a.service;


import com.ejie.x38.dto.Pagination;
import java.util.ArrayList;
import java.util.List;

import com.ejie.y38a.model.Provinci;

/**
 *  * ProvinciService  
 *  
 */

public interface ProvinciService {

	/**
	 * Inserts a single row in the Provinci table.
	 *
	 * @param provinci Provinci
	 * @return Provinci
	 */
    Provinci add(Provinci provinci);

	/**
	 * Updates a single row in the Provinci table.
	 *
	 * @param provinci Provinci
	 * @return Provinci
	 */
	Provinci update(Provinci provinci);

	/**
	 * Finds a single row in the Provinci table.
	 *
	 * @param provinci Provinci
	 * @return Provinci
	 */
	Provinci find(Provinci provinci);

	/**
	 * Finds a List of rows in the Provinci table.
	 *
	 * @param provinci Provinci
	 * @param pagination Pagination
	 * @return List
	 */
	List<Provinci> findAll(Provinci provinci, Pagination pagination);

	/**
	 * Counts rows in the Provinci table.
	 *
	 * @param provinci Provinci
	 * @return Long
	 */
	Long findAllCount(Provinci provinci);
	
	/**
	 * Finds rows in the Provinci table using like.
	 *
	 * @param provinci Provinci
	 * @param pagination Pagination
     * @param startsWith Boolean	 
	 * @return List
	 */
	List<Provinci> findAllLike(Provinci provinci, Pagination pagination, Boolean startsWith) ;
  
	/**
	 * Deletes a single row in the Provinci table.
	 *
	 * @param provinci Provinci
	 * @return 
	 */
	void remove(Provinci provinci);
	
	/**
	 * Deletes multiple rows in the Provinci table.
	 *
	 * @param provinciList  ArrayList
	 * @return 
	 */	
	void removeMultiple(ArrayList<Provinci> provinciList);
    
}


