package com.ejie.y38a.service;


import com.ejie.x38.dto.Pagination;
import java.util.ArrayList;
import java.util.List;

import com.ejie.y38a.model.Secagrup;

/**
 *  * SecagrupService  
 *  
 */

public interface SecagrupService {

	/**
	 * Inserts a single row in the Secagrup table.
	 *
	 * @param secagrup Secagrup
	 * @return Secagrup
	 */
    Secagrup add(Secagrup secagrup);

	/**
	 * Updates a single row in the Secagrup table.
	 *
	 * @param secagrup Secagrup
	 * @return Secagrup
	 */
	Secagrup update(Secagrup secagrup);

	/**
	 * Finds a single row in the Secagrup table.
	 *
	 * @param secagrup Secagrup
	 * @return Secagrup
	 */
	Secagrup find(Secagrup secagrup);

	/**
	 * Finds a List of rows in the Secagrup table.
	 *
	 * @param secagrup Secagrup
	 * @param pagination Pagination
	 * @return List
	 */
	List<Secagrup> findAll(Secagrup secagrup, Pagination pagination);

	/**
	 * Counts rows in the Secagrup table.
	 *
	 * @param secagrup Secagrup
	 * @return Long
	 */
	Long findAllCount(Secagrup secagrup);
	
	/**
	 * Finds rows in the Secagrup table using like.
	 *
	 * @param secagrup Secagrup
	 * @param pagination Pagination
     * @param startsWith Boolean	 
	 * @return List
	 */
	List<Secagrup> findAllLike(Secagrup secagrup, Pagination pagination, Boolean startsWith) ;
  
	/**
	 * Deletes a single row in the Secagrup table.
	 *
	 * @param secagrup Secagrup
	 * @return 
	 */
	void remove(Secagrup secagrup);
	
	/**
	 * Deletes multiple rows in the Secagrup table.
	 *
	 * @param secagrupList  ArrayList
	 * @return 
	 */	
	void removeMultiple(ArrayList<Secagrup> secagrupList);
    
}


