package com.ejie.y38a.service;

import java.util.ArrayList;
import java.util.List;

import com.ejie.x38.dto.Pagination;
import com.ejie.y38a.model.T17Pais;

/**
 * T17PaisService  
 * 
 *  
 */
public interface T17PaisService {

	/**
	 * Inserts a single row in the T17Pais table.
	 * 
	 * @param t17Pais
	 *            T17Pais
	 * @return T17Pais
	 */
	T17Pais add(T17Pais t17Pais);

	/**
	 * Updates a single row in the T17Pais table.
	 * 
	 * @param t17Pais
	 *            T17Pais
	 * @return T17Pais
	 */
	T17Pais update(T17Pais t17Pais);

	/**
	 * Finds a single row in the T17Pais table.
	 * 
	 * @param t17Pais
	 *            T17Pais
	 * @return T17Pais
	 */
	T17Pais find(T17Pais t17Pais);

	/**
	 * Finds a List of rows in the T17Pais table.
	 * 
	 * @param t17Pais
	 *            T17Pais
	 * @param pagination
	 *            Pagination
	 * @return List
	 */
	List<T17Pais> findAll(T17Pais t17Pais, Pagination pagination);

	/**
	 * Counts rows in the T17Pais table.
	 * 
	 * @param t17Pais
	 *            T17Pais
	 * @return Long
	 */
	Long findAllCount(T17Pais t17Pais);

	/**
	 * Finds rows in the T17Pais table using like.
	 * 
	 * @param t17Pais
	 *            T17Pais
	 * @param pagination
	 *            Pagination
	 * @return List
	 */
	List<T17Pais> findAllLike(T17Pais t17Pais, Pagination pagination,
			Boolean startsWith);

	/**
	 * Deletes a single row in the T17Pais table.
	 * 
	 * @param t17Pais
	 *            T17Pais
	 */
	void remove(T17Pais t17Pais);

	/**
	 * Deletes multiple rows in the T17Pais table.
	 * 
	 * @param t17PaisList
	 *            ArrayList
	 */
	void removeMultiple(ArrayList<T17Pais> t17PaisList);

}
