package com.ejie.y38a.utils;

import java.util.Properties;

import javax.mail.BodyPart;
import javax.mail.Message;
import javax.mail.MessagingException;
import javax.mail.Multipart;
import javax.mail.PasswordAuthentication;
import javax.mail.Session;
import javax.mail.Transport;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeBodyPart;
import javax.mail.internet.MimeMessage;
import javax.mail.internet.MimeMultipart;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.ejie.y38a.constantes.Y38aEstablecAdheConstantes;
import com.ejie.y38a.utils.beans.MailItemBean;

/**
 * 
 *  
 * 
 */
public class Y38aSendMail {

	private static final Logger logger = LoggerFactory
			.getLogger(Y38aSendMail.class);

	/**
	 * 
	 * @param item
	 *            MailItemBean
	 * @throws MessagingException
	 *             MessagingException
	 */
	public void sendItem(MailItemBean item) throws MessagingException {

		Properties prop = Y38aUtils
				.loadProperties(Y38aEstablecAdheConstantes.CONFIG_PATH);
		String local = (String) prop.getProperty("y38aVistaWar.entorno.local");
		Session session = null;
		String fromAddress = prop.getProperty("mail_fromAddress");
		/*
		 * String host=""; int port = 0;
		 */
		final String username;
		final String password;

		if ("true".equals(local)) {
			Properties props = new Properties();
			username = prop.getProperty("y38aVistaWar.mail.local.username");
			password = prop.getProperty("y38aVistaWar.mail.local.password");

			props.put("mail.smtp.host",
					(String) prop.getProperty("y38aVistaWar.mail.local.smtp"));
			props.put("mail.smtp.auth", "true");
			props.put("mail.smtp.starttls.enable", "true");
			props.put("mail.smtp.port",
					(String) prop.getProperty("y38aVistaWar.mail.local.port"));

			try {
				session = Session.getDefaultInstance(props,
						new javax.mail.Authenticator() {
							protected PasswordAuthentication getPasswordAuthentication() {
								return new PasswordAuthentication(username,
										password);
							}
						});

			} catch (Exception e) {
				Y38aSendMail.logger.error("Problema en Authentication "
						+ e.getMessage());
				// e.printStackTrace();
			}

		} else {
			Properties props = new Properties();
			props.put("mail.transport.protocol", "smtp");
			props.put("mail.smtp.host",
					(String) prop.getProperty("y38aVistaWar.mail.ejie.smtp"));
			session = Session.getInstance(props);

		}

		Message message = new MimeMessage(session);
		message.setFrom(new InternetAddress(fromAddress));
		message.setRecipients(Message.RecipientType.TO,
				InternetAddress.parse(item.getDestinatario()));
		message.setSubject(item.getAsunto());

		// Create the message part
		BodyPart messageBodyPart = new MimeBodyPart();

		// Fill the message
		messageBodyPart.setContent(item.getMensaje(),
				"text/html; charset=ISO8859_1");

		Multipart multipart = new MimeMultipart();
		multipart.addBodyPart(messageBodyPart);

		// Put parts in message
		message.setContent(multipart);

		// Transport transport = session.getTransport("smtp");
		// transport.connect(host, port, username, password);
		Transport.send(message);

		Y38aSendMail.logger.info("Correo enviado con exito!!");

	}

}
